<?php

require_once 'config.php';
require_once 'incl/main.php';
require_once 'version.php';

$rbox_keyword_symbols='°₿€£';

function stripc($n){
$n=trim($n); $n=preg_replace('/[^\p{L}\p{N}]/u','',$n);
$n=substr($n,0,6); return $n;}

function abc123a($n,$s){
$n=trim($n);
$pattern='/[^\p{L}\p{N} \-'.$s.']/u';
$n=preg_replace($pattern,'',$n);
$n=preg_replace('/([\s])\1+/',' ',$n);
return $n;}

neutral_dbconnect(); $settings=get_settings();

require_once 'lang/admin_english.utf8';

/* --- */

$whattodo='getuser';

    if(isset($_COOKIE[$xcookie_uidhash[0]])){ require_once 'ext/blabws.php'; }
elseif(isset($_COOKIE[$settings['intg_cookie']]) && $settings['intg_bbcms'] != 'blabws'){ require_once 'ext/'.$settings['intg_bbcms'].'.php'; }
elseif(isset($_COOKIE[$xcookie_appcode[0]])){require_once 'ext/blabwsappcode.php';}
else{ redirect('nolog.php');die(); }

if(!isset($xuser['id']) || !$xuser['name'] || !isset($xuser['group']) || !isset($permissions)){header('location:info.php?q=nop');die();}

if($xuser['id']==1){foreach($permissions as &$value){$value=1;}unset($value);}
if($permissions['c']<1 && $permissions['d']<1){header('location:info.php?q=nop');die();}

/* --- */

$badgebgc=$settings['badge_bgc'];
$badgeclr=makeclr($badgebgc);

/* ---  */

if($permissions['c']>0){ // starts readonly permissions restriction

/* --- */

if(isset($_GET['csv']) && function_exists('fputcsv')){

function outputcsv($data){
ob_start(); $csv = fopen("php://output", 'w');
foreach($data as $row){fputcsv($csv, $row);}
fclose($csv); return ob_get_clean();}

switch($_GET['csv']){
case 'users'   : $tbl=$dbss['prfx'].'_users'; break;
case 'social'  : $tbl=$dbss['prfx'].'_social'; break;
case 'settings': $tbl=$dbss['prfx'].'_settings'; break;
case 'rooms'   : $tbl=$dbss['prfx'].'_rooms'; break;
case 'groups'  : $tbl=$dbss['prfx'].'_groups'; break;
default        : break;}

if(!isset($tbl)){redirect('admin.php?q=dbopt');}

$res=neutral_query('SELECT * FROM '.$tbl);

$csv=outputcsv($res);
$size=strlen($csv); $csvname=$tbl.'.csv';

header('Content-Type: application/octet-stream');
header('Content-Length: '.$size);
header('Content-Transfer-Encoding: binary');
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Content-Disposition: attachment; filename="'.$csvname.'"');
header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
print $csv; die();}

/* --- */

if(isset($_GET['chaton'])){
$onoff=(int)$_GET['chaton']; if($onoff>1){$onoff=1;}
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$onoff' WHERE id='chaton'");
redirect('admin.php?ok='.$timestamp);}

if(isset($_POST['chatoff'])){
$chatoff=@base64_decode($_POST['chatoff']);
$chatoff=neutral_escape($chatoff,32000,'txt');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$chatoff' WHERE id='chatoff'");
redirect('admin.php?ok='.$timestamp); }

/* --- */

if(isset($_GET['massgedit']) && isset($_GET['action'])){
$action=(int)$_GET['action'];if($action>1 || $action<0){$action=1;}
$grppms=substr($_GET['massgedit'],0,1);
$avapms=array('f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z');
if(in_array($grppms,$avapms)){$grppms='p'.$grppms;
neutral_query('UPDATE '.$dbss['prfx']."_groups SET $grppms=$action");}
redirect('admin.php?q=groups&ok='.$timestamp);
}

/* --- */

if(isset($_POST['1']) && isset($_POST['17']) && isset($_POST['colors'])){

$a=$settings['style_template'];

$b=neutral_escape($_POST['1'],2,'int');   $a=str_replace('[1]',$b,$a); neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=1");
$b=neutral_escape($_POST['2'],999,'str'); $a=str_replace('[2]',$b,$a); neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=2");
$b=@base64_decode($_POST['3']); $b=neutral_escape($b,19999,'str');$a=str_replace('[3]',$b,$a); neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=3");
$b=@base64_decode($_POST['17']);$b=neutral_escape($b,19999,'str');$a=str_replace('[17]',$b,$a); neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=17");
$b=stripc($_POST['4']);   $a=str_replace('[4]',$b,$a); neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=4");
$b=stripc($_POST['5']);   $a=str_replace('[5]',$b,$a); neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=5"); $tinting_o='#'.$b;
$b=stripc($_POST['6']);   $a=str_replace('[6]',$b,$a); neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=6");
$b=stripc($_POST['7']);   $a=str_replace('[7]',$b,$a); neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=7");
$b=stripc($_POST['8']);   $a=str_replace('[8]',$b,$a); neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=8");
$b=stripc($_POST['9']);   $a=str_replace('[9]',$b,$a); neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=9");
$b=stripc($_POST['10']);  $a=str_replace('[10]',$b,$a);neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=10");
$b=stripc($_POST['11']);  $a=str_replace('[11]',$b,$a);neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=11");
$b=stripc($_POST['12']);  $a=str_replace('[12]',$b,$a);neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=12");
$b=stripc($_POST['13']);  $a=str_replace('[13]',$b,$a);neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=13");
$b=stripc($_POST['14']);  $a=str_replace('[14]',$b,$a);neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=14"); $tinting_c='#'.$b;
$b=neutral_escape($_POST['15'],3,'int');  $a=str_replace('[15]',$b,$a);neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=15");
$b=neutral_escape($_POST['16'],3,'int');  $a=str_replace('[16]',$b,$a);neutral_query('UPDATE '.$dbss['prfx']."_style SET value='$b' WHERE id=16");
$fgaccenttxt=makeclr(stripc($_POST['6'])); $a=str_replace('[0]',$fgaccenttxt,$a);

neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$a' WHERE id='style_delivery'");

$colors=neutral_escape($_POST['colors'],9999,'txt');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$colors' WHERE id='colors'");

if(isset($_POST['webkit_css'])){ 
$x=@base64_decode($_POST['webkit_css']); $x=neutral_escape($x,32000,'txt');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='webkit_css'");}
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$tinting_c' WHERE id='tinting_c'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$tinting_o' WHERE id='tinting_o'");

redirect('admin.php?q=style&ok='.$timestamp); }

/* --- */

if(isset($_POST['webkit_css'])){ 
$x=@base64_decode($_POST['webkit_css']); $x=neutral_escape($x,32000,'txt');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='webkit_css'");
redirect('admin.php?q=customcss&ok='.$timestamp); }

/* --- */

if(isset($_POST['splash'])){ 
$x=@base64_decode($_POST['splash']); $x=neutral_escape($x,32000,'txt');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='splash'");
redirect('admin.php?q=splash&ok='.$timestamp); }

/* --- */

if(isset($_POST['seo_page'])){ 
$x=@base64_decode($_POST['seo_page']); $x=neutral_escape($x,32000,'txt');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='seo_page'");
redirect('admin.php?q=seo&ok='.$timestamp); }

/* --- */

if(isset($_GET['splashtemplate'])){
$x=abc123a($_GET['splashtemplate'],'');
if(is_file('splash/'.$x.'.html')){
$x=file_get_contents('splash/'.$x.'.html');
$x=neutral_escape($x,32000,'txt');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='splash'");
} redirect('admin.php?q=splash&ok='.$timestamp); }

/* --- */

if(isset($_POST['notes'])){
$notes=@base64_decode($_POST['notes']);
$notes=neutral_escape($notes,32000,'txt');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$notes' WHERE id='notes'");
redirect('admin.php?ok='.$timestamp); }

/* --- */

if($xuser['id']==1 && isset($_GET['addrule'])){
$zorder=substr($timestamp,-4);if($zorder<1000){$zorder+=1000;}
neutral_query('INSERT INTO '.$dbss['prfx']."_grules VALUES(NULL,'Dummy rule. Click «Make rule» to adjust...','',0,$zorder)");
redirect('admin.php?q=grules&ok='.$timestamp); }

if($xuser['id']==1 && isset($_GET['delrule'])){
$delrule=(int)$_GET['delrule'];
neutral_query('DELETE FROM '.$dbss['prfx']."_grules WHERE id=$delrule");
redirect('admin.php?q=grules&ok='.$timestamp); }

if($xuser['id']==1 && isset($_POST['gruid']) && isset($_POST['ugroup']) && isset($_POST['zorder']) && isset($_POST['description']) && isset($_POST['scenario'])){
$gruid=(int)$_POST['gruid'];
$ugroup=(int)$_POST['ugroup'];
$zorder=(int)$_POST['zorder'];
$description=neutral_escape($_POST['description'],250,'txt');
$scenario=neutral_escape($_POST['scenario'],5000,'txt');
neutral_query('UPDATE '.$dbss['prfx']."_grules SET ugroup='$ugroup',zorder=$zorder,description='$description',scenario='$scenario' WHERE id=$gruid");
redirect('admin.php?q=grules&ok='.$timestamp); }

/* --- */

if(isset($_POST['group_g'])){
$group_g=(int)$_POST['group_g'];
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$group_g' WHERE id='group_g'");
redirect('admin.php?q=groups&ok='.$timestamp); }

/* --- */

if(isset($_POST['group_r'])){
$group_r=(int)$_POST['group_r'];
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$group_r' WHERE id='group_r'");
redirect('admin.php?q=groups&ok='.$timestamp); }

/* --- */

if(isset($_POST['group_f'])){
$group_f=(int)$_POST['group_f'];
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$group_f' WHERE id='group_f'");
redirect('admin.php?q=groups&ok='.$timestamp); }

/* --- */

if(isset($_GET['ban_order'])){
$ban_order=(int)$_GET['ban_order'];
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$ban_order' WHERE id='ban_order'");
redirect('admin.php?q=bans&ok='.$timestamp); }

if(isset($_GET['unban'])){ $id=(int)$_GET['unban'];
neutral_query('DELETE FROM '.$dbss['prfx']."_ban WHERE id=$id");
redirect('admin.php?q=bans&ok='.$timestamp); }

if(isset($_GET['banip'])){ $banip=trim($_GET['banip']); 
if(!preg_match('/[^\p{L}\p{N}\.\:]/',$banip)){ $banip=neutral_escape($banip,64,'str'); $ban_period=$timestamp+2592000;
if(strlen($banip)>4){neutral_query('INSERT INTO '.$dbss['prfx']."_ban VALUES(NULL,0,'unknown','$banip',$timestamp,$ban_period,3,1,'ACP','')");}}
redirect('admin.php?q=bans&ok='.$timestamp); }

if(isset($_POST['whattodo']) && isset($_POST['multibusr']) && is_array($_POST['multibusr']) && count($_POST['multibusr'])>0){
$whattodo=(int)$_POST['whattodo']; $multibusr=$_POST['multibusr'];
for($i=0;$i<count($multibusr);$i++){$multibusr[$i]=(int)$multibusr[$i];}
$dbinit=implode(',',$multibusr);
if($whattodo>0){neutral_query('UPDATE '.$dbss['prfx']."_ban SET timestamp=timestamp+$whattodo WHERE id IN ($dbinit)");}
else{neutral_query('DELETE FROM '.$dbss['prfx']."_ban WHERE id IN ($dbinit)");}
redirect('admin.php?q=bans&ok='.$timestamp); }

/* --- */

if(isset($_POST['nbox_sender_id']) && isset($_POST['nbox_sender_name']) && isset($_POST['nbox_sender_group'])){
$nbox_sender_id=(int)$_POST['nbox_sender_id']; if($nbox_sender_id<1){$nbox_sender_id=1;}
$nbox_sender_group=(int)$_POST['nbox_sender_group']; if($nbox_sender_group<1){$nbox_sender_group=1;}
$nbox_sender_name=abc123a($_POST['nbox_sender_name'],'');if(length($nbox_sender_name)<3){$nbox_sender_name='NewsMaster';}
$nbox_sender=$nbox_sender_id.':'.$nbox_sender_group.':'.$nbox_sender_name;
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$nbox_sender' WHERE id='nbox_sender'");
redirect('admin.php?q=nbox&ok='.$timestamp);}

if(isset($_POST['newsapi_key'])){
$newsapi_key=neutral_escape($_POST['newsapi_key'],64,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$newsapi_key' WHERE id='newsapi_key'");
redirect('admin.php?q=nbox&ok='.$timestamp);}

if(isset($_GET['addnewsst'])){
neutral_query('INSERT INTO '.$dbss['prfx']."_nbox VALUES(NULL,'SUBSET',1,0,0,0,0,50,'','topic','keyword1,keyword2')");
redirect('admin.php?q=nbox&ok='.$timestamp);}

if(isset($_GET['delsst'])){
$delsst=(int)$_GET['delsst'];
neutral_query('DELETE FROM '.$dbss['prfx'].'_nbox WHERE id='.$delsst);
redirect('admin.php?q=nbox&ok='.$timestamp);}

if(isset($_GET['delallsst'])){ 
neutral_query('DELETE FROM '.$dbss['prfx'].'_nbox');
redirect('admin.php?q=nbox&ok='.$timestamp);}

if(isset($_POST['sset'])){ 
$sset=(int)$_POST['sset']; $keywords='keyword';

if(isset($_POST['name'])){$name=preg_replace('/[^a-z0-9]/i','',$_POST['name']);}
if(!isset($name) || strlen($name)<3){$name='SUBSET';}

if(isset($_POST['enabled'])){$enabled=(int)$_POST['enabled'];}else{$enabled=0;}
if(isset($_POST['roomid'])){$roomid=(int)$_POST['roomid'];}else{$roomid=0;}
if(isset($_POST['ugroup'])){$ugroup=(int)$_POST['ugroup'];}else{$ugroup=0;}
if(isset($_POST['pagesize'])){$pagesize=(int)$_POST['pagesize'];if($pagesize<10 || $pagesize>100){$pagesize=50;}}else{$pagesize=50;}
if(isset($_POST['headlines'])){$headlines=(int)$_POST['headlines'];}else{$headlines=1;}
if(isset($_POST['topic'])){$topic=trim(abc123a($_POST['topic'],'')); $topic=neutral_escape($topic,128,'str');}else{$topic='TOPIC';}
if(isset($_POST['origin'])){$origin=trim(abc123a($_POST['origin'],'')); $origin=neutral_escape($origin,2,'str');}else{$origin='';}

if(isset($_POST['keywords'])){
$input=explode(',',$_POST['keywords']);$output=array(); 
for($i=0;$i<count($input);$i++){$x=trim(abc123a($input[$i],'')); if(length($x)>2){$output[]=$x;}}
$keywords=implode(',',$output); $keywords=neutral_escape($keywords,5000,'txt');}

if(strlen($keywords)<3){$keywords='keyword';}

neutral_query('UPDATE '.$dbss['prfx']."_nbox SET name='$name',enabled=$enabled,headlines=$headlines,roomid=$roomid,ugroup=$ugroup,pagesize=$pagesize,origin='$origin',keywords='$keywords',topic='$topic' WHERE id=$sset");


redirect('admin.php?q=subset&id='.$sset.'&ok='.$timestamp);}

/* --- */

if(isset($_POST['rbox_sender_id']) && isset($_POST['rbox_sender_name']) && isset($_POST['rbox_sender_group'])){
$rbox_sender_id=(int)$_POST['rbox_sender_id']; if($rbox_sender_id<1){$rbox_sender_id=1;}
$rbox_sender_group=(int)$_POST['rbox_sender_group']; if($rbox_sender_group<1){$rbox_sender_group=1;}
$rbox_sender_name=abc123a($_POST['rbox_sender_name'],'');if(length($rbox_sender_name)<3){$rbox_sender_name='TheGodFather';}
$rbox_sender=$rbox_sender_id.':'.$rbox_sender_group.':'.$rbox_sender_name;
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$rbox_sender' WHERE id='rbox_sender'");
redirect('admin.php?q=rbox&ok='.$timestamp);}

if(isset($_GET['addnewidx'])){
neutral_query('INSERT INTO '.$dbss['prfx']."_rbox VALUES(NULL,'SUBSET',1,0,0,0,'keyword1,keyword2','phrase1\nphrase2\nphrase3')");
redirect('admin.php?q=rbox&ok='.$timestamp);}

if(isset($_GET['delidx'])){
$delidx=(int)$_GET['delidx'];
neutral_query('DELETE FROM '.$dbss['prfx'].'_rbox WHERE id='.$delidx);
redirect('admin.php?q=rbox&ok='.$timestamp);}

if(isset($_GET['delallidx'])){ 
neutral_query('DELETE FROM '.$dbss['prfx'].'_rbox');
redirect('admin.php?q=rbox&ok='.$timestamp);}

if(isset($_POST['idx'])){ 
$idx=(int)$_POST['idx']; $keywords='keyword'; $answers='Hello there!';

if(isset($_POST['name'])){$name=preg_replace('/[^a-z0-9]/i','',$_POST['name']);}
if(!isset($name) || strlen($name)<3){$name='SUBSET';}

if(isset($_POST['enabled'])){$enabled=(int)$_POST['enabled'];}else{$enabled=0;}
if(isset($_POST['roomid'])){$roomid=(int)$_POST['roomid'];}else{$roomid=0;}
if(isset($_POST['ugroup'])){$ugroup=(int)$_POST['ugroup'];}else{$ugroup=0;}
if(isset($_POST['pm'])) {$pm=(int)$_POST['pm'];} else{$pm=0;}
if($pm==0 && $roomid>0){$pm=-1;}

if(isset($_POST['keywords'])){
$tkw=@base64_decode($_POST['keywords']);
$input=explode(',',$tkw);$output=array(); 
for($i=0;$i<count($input);$i++){$x=trim(abc123a($input[$i],$rbox_keyword_symbols)); if(length($x)>1){$output[]=$x;}}
$keywords=implode(',',$output); $keywords=neutral_escape($keywords,5000,'txt');}

if(isset($_POST['answers'])){
$answers=@base64_decode($_POST['answers']);
$input=str_replace("\r",'',$answers); $input=explode("\n",$input); $output=array(); 
for($i=0;$i<count($input);$i++){$x=trim($input[$i]); if(length($x)>0){$output[]=$x;}}
$answers=implode("\n",$output); $answers=neutral_escape($answers,64000,'txt');}

if(strlen($keywords)<3){$keywords='keyword';}
if(strlen($answers)<1){$answers='Hello there!';}

neutral_query('UPDATE '.$dbss['prfx']."_rbox SET name='$name',enabled=$enabled,roomid=$roomid,ugroup=$ugroup,pm=$pm,keywords='$keywords',answers='$answers' WHERE id=$idx");
redirect('admin.php?q=idx&id='.$idx.'&ok='.$timestamp);
}

/* --- */

if(isset($_GET['addnewbling'])){
$randbgc=[['000000','FFFFFF'],['FFFFFF','0277BD'],['FFFFFF','AD1457'],['000000','EF9A9A'],['000000','B39DDB'],['000000','FFF176'],['FFFFFF','827717'],['FFFFFF','EF6C00'],['FFFFFF','00695C']];
$ccoupl=$randbgc[array_rand($randbgc)]; $fgc=$ccoupl[0];$bgc=$ccoupl[1]; $fcolor='#'.$fgc;$bcolor='#'.$bgc;
$randstr=rand_str(20);
$newbling='<div style="top:0; left:0; bottom:0; right:0; position:fixed; font-size:15vw; line-height:100vh; color:'.$fcolor.'; text-align:center">BLING!</div>';
neutral_query('INSERT INTO '.$dbss['prfx']."_bbox VALUES(NULL,'NEWBLING','$fgc','$bgc','$randstr',0,0,0,4000,'$bcolor','','$newbling','')");

redirect('admin.php?q=bbox&ok='.$timestamp);}

if(isset($_GET['delbling'])){
$delbling=(int)$_GET['delbling'];
neutral_query('DELETE FROM '.$dbss['prfx'].'_bbox WHERE id='.$delbling);
redirect('admin.php?q=bbox&ok='.$timestamp);}

if(isset($_GET['delallbling'])){ 
neutral_query('DELETE FROM '.$dbss['prfx'].'_bbox');
redirect('admin.php?q=bbox&ok='.$timestamp);}

if(isset($_POST['blingon']) && isset($_POST['blingint'])){
$blingon=(int)$_POST['blingon'];
$blingint=(int)$_POST['blingint']; if($blingint<10 || $blingint>3600){$blingint=20;}
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$blingon' WHERE id='blingon'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$blingint' WHERE id='blingint'");
redirect('admin.php?q=bbox&ok='.$timestamp);}

/* --- */

if(isset($_POST['blingid']) && isset($_POST['name']) && isset($_POST['bgc']) && isset($_POST['blingkey']) && isset($_POST['enabled']) && isset($_POST['inlist']) && isset($_POST['blingsuper']) && isset($_POST['timesec']) && isset($_POST['bgcolor']) && isset($_POST['sound']) && isset($_POST['blingcode']) && isset($_POST['blingcss'])){

$blingid=(int)$_POST['blingid'];
$name=neutral_escape($_POST['name'],64,'str'); if(strlen($name)<1){$name='BLING!';}
$blingkey=str_replace(' ','',abc123a($_POST['blingkey'],'')).rand_str(20); 
$blingkey=neutral_escape($blingkey,20,'str'); 
$bgc=stripc($_POST['bgc']); $fgc=makeclr($bgc);

$enabled=(int)$_POST['enabled'];
$inlist=(int)$_POST['inlist'];
$blingsuper=(int)$_POST['blingsuper'];
$timesec=(int)$_POST['timesec']; if($timesec<999 || $timesec>999999){$timesec=4000;}
$bgcolor=neutral_escape($_POST['bgcolor'],64,'str');
$sound=neutral_escape($_POST['sound'],256,'str');
$blingcode=base64_decode($_POST['blingcode']); $blingcode=neutral_escape($blingcode,32000,'txt');
$blingcss=base64_decode($_POST['blingcss']); $blingcss=neutral_escape($blingcss,32000,'txt');

neutral_query('UPDATE '.$dbss['prfx']."_bbox SET name='$name',fgc='$fgc',bgc='$bgc',blingkey='$blingkey',enabled=$enabled,inlist=$inlist,blingsuper=$blingsuper,timesec=$timesec,bgcolor='$bgcolor',sound='$sound',blingcode='$blingcode',blingcss='$blingcss' WHERE id=$blingid");

redirect('admin.php?q=bling&id='.$blingid.'&ok='.$timestamp);}

/* --- */

if(isset($_GET['addnewseq'])){
neutral_query('INSERT INTO '.$dbss['prfx']."_jbox VALUES(NULL,'SEQUENCE',1,0,0,1,0,30,0,0,1,'message 1<br />\nmessage 2<br />\nmessage 3<br />\nmessage 4<br />\nmessage 5<br />','{TEXT}')");
redirect('admin.php?q=jbox&ok='.$timestamp);}

if(isset($_GET['delsequence'])){
$delsequence=(int)$_GET['delsequence'];
neutral_query('DELETE FROM '.$dbss['prfx'].'_jbox WHERE id='.$delsequence);
redirect('admin.php?q=jbox&ok='.$timestamp);}

if(isset($_GET['delallseq'])){ 
neutral_query('DELETE FROM '.$dbss['prfx'].'_jbox');
redirect('admin.php?q=jbox&ok='.$timestamp);}

if(isset($_POST['sequence'])){ 
$seqid=(int)$_POST['sequence']; $template='{TEXT}'; $elements='Hello!';

if(isset($_POST['name'])){$name=preg_replace('/[^a-z0-9]/i','',$_POST['name']);}
if(!isset($name) || strlen($name)<3){$name='SEQUENCE';}

if(isset($_POST['enabled'])){$enabled=(int)$_POST['enabled'];}else{$enabled=0;}
if(isset($_POST['roomid'])){$roomid=(int)$_POST['roomid'];}else{$roomid=0;}
if(isset($_POST['ugroup'])){$ugroup=(int)$_POST['ugroup'];}else{$ugroup=0;}
if(isset($_POST['infinite'])) {$infinite=(int)$_POST['infinite'];} else{$infinite=0;}
if(isset($_POST['shuffle'])) {$shuffle=(int)$_POST['shuffle'];} else{$shuffle=0;}
if(isset($_POST['gap'])) {$gap=(int)$_POST['gap'];} else{$gap=10;}
if(isset($_POST['delay'])) {$delay=(int)$_POST['delay'];} else{$delay=0;}
if(isset($_POST['cookielength'])) {$cookielength=(int)$_POST['cookielength'];} else{$cookielength=0;}
if(isset($_POST['hremember'])) {$hremember=(int)$_POST['hremember'];} else{$hremember=1;}

if(isset($_POST['template'])){
	$template=@base64_decode($_POST['template']);
	$template=neutral_escape($template,5000,'txt');}

if(isset($_POST['elements'])){
	$elements=@base64_decode($_POST['elements']);
	$elements=neutral_escape($elements,64000,'txt');}
	
if(strlen($template)<6){$template='{TEXT}';}
if(strlen($elements)<1){$elements='Hello!';}

neutral_query('UPDATE '.$dbss['prfx']."_jbox SET name='$name',enabled=$enabled,roomid=$roomid,ugroup=$ugroup,infinite=$infinite,shuffle=$shuffle,gap=$gap,delay=$delay,cookielength=$cookielength,hremember=$hremember,template='$template',elements='$elements' WHERE id=$seqid");
redirect('admin.php?q=sequence&id='.$seqid.'&ok='.$timestamp);
}

/* --- */

if(isset($_POST['gbox_sender_id']) && isset($_POST['gbox_sender_name']) && isset($_POST['gbox_sender_group'])){
$gbox_sender_id=(int)$_POST['gbox_sender_id']; if($gbox_sender_id<1){$gbox_sender_id=1;}
$gbox_sender_group=(int)$_POST['gbox_sender_group']; if($gbox_sender_group<1){$gbox_sender_group=1;}
$gbox_sender_name=abc123a($_POST['gbox_sender_name'],'');if(length($gbox_sender_name)<3){$gbox_sender_name='GIF Master';}
$gbox_sender=$gbox_sender_id.':'.$gbox_sender_group.':'.$gbox_sender_name;
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$gbox_sender' WHERE id='gbox_sender'");
redirect('admin.php?q=gbox&ok='.$timestamp);}

if(isset($_POST['gifs2key'])){
$gifs_key=neutral_escape($_POST['gifs2key'],64,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$gifs_key' WHERE id='gifs_key'");
redirect('admin.php?q=gbox&ok='.$timestamp);}

if(isset($_GET['addnewgft'])){
neutral_query('INSERT INTO '.$dbss['prfx']."_gbox VALUES(NULL,'SUBSET',1,0,0,50,'en','topic','keyword1,keyword2')");
redirect('admin.php?q=gbox&ok='.$timestamp);}

if(isset($_GET['delgft'])){
$delgft=(int)$_GET['delgft'];
neutral_query('DELETE FROM '.$dbss['prfx'].'_gbox WHERE id='.$delgft);
neutral_query('DELETE FROM '.$dbss['prfx'].'_gifs WHERE idgbox='.$delgft);
redirect('admin.php?q=gbox&ok='.$timestamp);}

if(isset($_GET['delallgft'])){ 
neutral_query('DELETE FROM '.$dbss['prfx'].'_gbox');
neutral_query('DELETE FROM '.$dbss['prfx'].'_gifs');
redirect('admin.php?q=gbox&ok='.$timestamp);}

if(isset($_POST['gset'])){ 
$gset=(int)$_POST['gset']; $keywords='keyword';

if(isset($_POST['name'])){$name=preg_replace('/[^a-z0-9]/i','',$_POST['name']);}
if(!isset($name) || strlen($name)<3){$name='SUBSET';}

if(isset($_POST['enabled'])){$enabled=(int)$_POST['enabled'];}else{$enabled=0;}
if(isset($_POST['roomid'])){$roomid=(int)$_POST['roomid'];}else{$roomid=0;}
if(isset($_POST['ugroup'])){$ugroup=(int)$_POST['ugroup'];}else{$ugroup=0;}
if(isset($_POST['pagesize'])){$pagesize=(int)$_POST['pagesize'];if($pagesize<10 || $pagesize>50){$pagesize=50;}}else{$pagesize=50;}
if(isset($_POST['topic'])){$topic=trim(abc123a($_POST['topic'],'')); $topic=neutral_escape($topic,128,'str');}else{$topic='TOPIC';}
if(isset($_POST['glocale'])){$glocale=trim(abc123a($_POST['glocale'],'')); $glocale=neutral_escape($glocale,2,'str');}else{$glocale='en';}

if(isset($_POST['keywords'])){
$input=explode(',',$_POST['keywords']);$output=array(); 
for($i=0;$i<count($input);$i++){$x=trim(abc123a($input[$i],'')); if(length($x)>2){$output[]=$x;}}
$keywords=implode(',',$output); $keywords=neutral_escape($keywords,5000,'txt');}

if(strlen($keywords)<3){$keywords='keyword';}

neutral_query('UPDATE '.$dbss['prfx']."_gbox SET name='$name',enabled=$enabled,roomid=$roomid,ugroup=$ugroup,pagesize=$pagesize,glocale='$glocale',keywords='$keywords',topic='$topic' WHERE id=$gset");


redirect('admin.php?q=gset&id='.$gset.'&ok='.$timestamp);}

/* --- */


if(isset($_POST['abox_sender_id']) && isset($_POST['abox_sender_name']) && isset($_POST['abox_sender_group'])){
$abox_sender_id=(int)$_POST['abox_sender_id']; if($abox_sender_id<1){$abox_sender_id=1;}
$abox_sender_group=(int)$_POST['abox_sender_group']; if($abox_sender_group<1){$abox_sender_group=1;}
$abox_sender_name=abc123a($_POST['abox_sender_name'],'');if(length($abox_sender_name)<3){$abox_sender_name='Aunt Hedwig';}
$abox_sender=$abox_sender_id.':'.$abox_sender_group.':'.$abox_sender_name;
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$abox_sender' WHERE id='abox_sender'");
redirect('admin.php?q=abox&ok='.$timestamp);}

if(isset($_POST['abox_key']) && isset($_POST['abox_dtt'])){
$abox_key=neutral_escape($_POST['abox_key'],64,'str');
$abox_dtt=(int)$_POST['abox_dtt'];
if(strlen($abox_key)>8){neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$abox_key' WHERE id='abox_key'");}
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$abox_dtt' WHERE id='abox_dtt'");
redirect('admin.php?q=abox&ok='.$timestamp);}


/* --- */

if(isset($_POST['geo_center'])){

$latlon='35,33'; $geo_zoom_i=3; $geo_zoom_m=15; $geo_period=3600; $geo_timeout=5; $geo_error=5; $geo_grey=0; $geo_max=50;

if(strstr($_POST['geo_center'],',')){
$geocenter=explode(',',$_POST['geo_center']);
$lat=(float)$geocenter[0]; $lon=(float)$geocenter[1];
if($lat<-90 || $lat>90 || $lon<-180 && $lon>180){$lat=35;$lon=33;}
$latlon=$lat.','.$lon;}

if(isset($_POST['geo_zoom_i'])){$geo_zoom_i=(int)$_POST['geo_zoom_i'];
if($geo_zoom_i<3 || $geo_zoom_i>12){$geo_zoom_i=3;}}

if(isset($_POST['geo_zoom_m'])){$geo_zoom_m=(int)$_POST['geo_zoom_m'];
if($geo_zoom_m<5 || $geo_zoom_m>20){$geo_zoom_m=15;}}

if(isset($_POST['geo_period'])){$geo_period=(int)$_POST['geo_period'];
if($geo_period<1800 || $geo_period>604800){$geo_period=3600;}}

if(isset($_POST['geo_timeout'])){$geo_timeout=(int)$_POST['geo_timeout'];
if($geo_timeout<5 || $geo_timeout>60){$geo_timeout=5;}}

if(isset($_POST['geo_error'])){$geo_error=(int)$_POST['geo_error'];
if($geo_error<1 || $geo_error>100){$geo_error=5;}}

if(isset($_POST['geo_grey'])){$geo_grey=(int)$_POST['geo_grey'];
if($geo_grey<0 || $geo_grey>1){$geo_grey=0;}}

if(isset($_POST['geo_max'])){$geo_max=(int)$_POST['geo_max'];
if($geo_max<10 || $geo_max>100){$geo_max=50;}}

neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$latlon' WHERE id='geo_center'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$geo_zoom_i' WHERE id='geo_zoom_i'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$geo_zoom_m' WHERE id='geo_zoom_m'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$geo_period' WHERE id='geo_period'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$geo_timeout' WHERE id='geo_timeout'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$geo_error' WHERE id='geo_error'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$geo_grey' WHERE id='geo_grey'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$geo_max' WHERE id='geo_max'");

redirect('admin.php?q=mapsetts&ok='.$timestamp);
}

/* --- */

if(isset($_POST['fb_appid']) && isset($_POST['fb_token']) && isset($_POST['fb_r_url']) && isset($_POST['fb_t_frm'])){ 

$fb_appid=neutral_escape($_POST['fb_appid'],128,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$fb_appid' WHERE id='fb_appid'");

$fb_token=neutral_escape($_POST['fb_token'],128,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$fb_token' WHERE id='fb_token'");

$fb_r_url=neutral_escape($_POST['fb_r_url'],256,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$fb_r_url' WHERE id='fb_r_url'");

$fb_t_frm=neutral_escape($_POST['fb_t_frm'],256,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$fb_t_frm' WHERE id='fb_t_frm'");

redirect('admin.php?q=fbook&ok='.$timestamp); }

/* --- */

if(isset($_POST['vote_seeres']) && isset($_POST['vote_change']) && isset($_POST['vote_ipaddr']) && isset($_POST['vote_colors'])){

$vote_seeres=(int)$_POST['vote_seeres'];
$vote_change=(int)$_POST['vote_change'];
$vote_ipaddr=(int)$_POST['vote_ipaddr'];
$vote_colors=explode(',',$_POST['vote_colors']);

for($i=0;$i<10;$i++){
if(isset($vote_colors[$i])){
$vote_colors[$i]=stripc($vote_colors[$i]);}
else{$vote_colors[$i]='aa000';}}
$vote_colors=implode(',',$vote_colors);
$vote_colors=neutral_escape($vote_colors,70,'str');

neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vote_seeres' WHERE id='vote_seeres'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vote_change' WHERE id='vote_change'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vote_ipaddr' WHERE id='vote_ipaddr'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vote_colors' WHERE id='vote_colors'");

redirect('admin.php?q=polls&ok='.$timestamp);
}

/* --- */

if(isset($_POST['qui_limit']) && isset($_POST['min_qstat']) && isset($_POST['qui_icons'])){

$qui_limit=(int)$_POST['qui_limit'];
$min_qstat=(int)$_POST['min_qstat'];

$qui_icons=array(); $quipicons=explode(',',$_POST['qui_icons']);
for($i=0;$i<count($quipicons);$i++){$u=trim($quipicons[$i]);if(length($u)==1){$qui_icons[]=$u;}}

if(count($qui_icons)>0){$qui_icons=implode(',',$qui_icons);} else{
$qui_icons='🍏,🍎,🍐,🍊,🍋,🍒,💦,🍉,🍇,🍓,🍒,🥭,🥥,🥦,🥑,🥝,🌽,🧄,🧅,🌹,🌴,🍀,🍄,💐,🌵,🌲,🌻,🌼,🌺,🍁,🐹,🐰,🦊,🐻,🐼,🐨,🦁,🐷,🐸,🙊,🐧,🐦,🦅,🦉,🐝,🦋,🐌,🐞,🦑,🦀,🐡,🐠,🐟,🦓,🐪,🦒,🐃,🦌,🐓,🦃,🦚,🦜,🦩,🕊,⭐,🚗,🚎,🚑,🚜,🚠,🚦';
if($dbss['cset']=='utf8'){$qui_icons='★,✿,✽,❊,✤,⚘,♠,❤,♦,♣';}}

neutral_query('UPDATE '.$dbss['sprf']."_settings SET value='$qui_limit' WHERE id='qui_limit'");
neutral_query('UPDATE '.$dbss['sprf']."_settings SET value='$min_qstat' WHERE id='min_qstat'");
neutral_query('UPDATE '.$dbss['sprf']."_settings SET value='$qui_icons' WHERE id='qui_icons'");

redirect('admin.php?q=quizzes&ok='.$timestamp);
}

/* --- */

if(isset($_POST['edituser']) && isset($_POST['email'])){
$id=(int)$_POST['edituser']; $ok='';

$res=neutral_query('SELECT * FROM '.$dbss['prfx']."_users WHERE id=$id");
if(neutral_num_rows($res)<1){redirect('admin.php?q=users');die();}
$user=neutral_fetch_array($res);

if(isset($_POST['group']) && $_POST['group']!=$user['ugroup']){
$gid=(int)$_POST['group'];$ok='&ok='.$timestamp;
neutral_query('UPDATE '.$dbss['prfx']."_users SET ugroup='$gid' WHERE id=$id");}

if(isset($_POST['email']) && $_POST['email']!=$user['email'] && length($_POST['email'])>6 && stristr($_POST['email'],'@') && stristr($_POST['email'],'.')  && !stristr($_POST['email'],' ')){
$email=neutral_escape($_POST['email'],64,'str'); 
$res=neutral_query('SELECT * FROM '.$dbss['prfx']."_users WHERE email='$email'");
if(neutral_num_rows($res)<1){ $ok='&ok='.$timestamp;
neutral_query('UPDATE '.$dbss['prfx']."_users SET email='$email' WHERE id=$id");}}

if(isset($_POST['password']) && length($_POST['password'])>2){
$newpass=hash('sha256',trim($_POST['password']).$user['salt']); $ok='&ok='.$timestamp;
neutral_query('UPDATE '.$dbss['prfx']."_users SET password='$newpass' WHERE id=$id");} 

if(isset($_POST['question']) && isset($_POST['answer']) && length($_POST['question'])>0 && length($_POST['answer'])>0){
$question=neutral_escape($_POST['question'],128,'str');
$answer=hash('sha256',strtolower(trim($_POST['answer'])).$user['salt']);
$ok='&ok='.$timestamp;
neutral_query('UPDATE '.$dbss['prfx']."_users SET question='$question', answer='$answer' WHERE id=$id");} 

redirect('admin.php?q=user&id='.$id.$ok); }

/* --- */

if(isset($_POST['edituser']) && isset($_POST['motto']) && isset($_POST['avatar']) && isset($_POST['age']) && isset($_POST['location']) && isset($_POST['education']) && isset($_POST['occupation']) && isset($_POST['interests']) && isset($_POST['about']) && isset($_POST['cover']) && isset($_POST['gender'])){

$id=(int)$_POST['edituser']; $ok='&ok='.$timestamp;
$avatar=neutral_escape($_POST['avatar'],120,'str'); 
$motto=neutral_escape($_POST['motto'],32,'str');
$age=(int)$_POST['age']; if(date('Y')-$age<16 || date('Y')-$age>99){$age=0;}
$location=neutral_escape($_POST['location'],64,'str');
$gender=neutral_escape($_POST['gender'],32,'str');
$education=neutral_escape($_POST['education'],64,'str');
$occupation=neutral_escape($_POST['occupation'],64,'str');
$interests=neutral_escape($_POST['interests'],64,'str');
$about=neutral_escape($_POST['about'],256,'txt');
$cover=neutral_escape($_POST['cover'],64,'str');

neutral_query('DELETE FROM '.$dbss['sprf']."_uxtra WHERE id=$id");
neutral_query('INSERT INTO '.$dbss['sprf']."_uxtra VALUES($id,'$avatar','$motto',$age,'$location','$gender','$education','$occupation','$interests','$cover','$about')");

redirect('admin.php?q=user&id='.$id.$ok);}

/* --- */

if(isset($_POST['fakeuser'])){
$id=$_POST['fakeuser']; 
if(isset($_POST['status'])){$status=(int)$_POST['status'];} if($status<1 || $status>5){$status=2;}
if(isset($_POST['hour_begin'])){$hour_begin=(int)$_POST['hour_begin'];} if($hour_begin<0 || $hour_begin>23){$hour_begin=0;}
if(isset($_POST['hour_end'])){$hour_end=(int)$_POST['hour_end'];} if($hour_end<1 || $hour_end>24){$hour_end=24;}
if($hour_end==$hour_begin || $hour_end<$hour_begin){$hour_begin=0;$hour_end=24;}
neutral_query('DELETE FROM '.$dbss['prfx']."_ufake WHERE id=$id");
neutral_query('DELETE FROM '.$dbss['prfx']."_geoloc WHERE id=$id");
neutral_query('INSERT INTO '.$dbss['prfx']."_ufake VALUES($id,'$status','$hour_begin','$hour_end')");

if(isset($_POST['fusrname']) && isset($_POST['coords']) && strstr($_POST['coords'],',')){
$coords=explode(',',$_POST['coords']);
$lat=(float)$coords[0];$lon=(float)$coords[1];
$fusrname=abc123a($_POST['fusrname'],'');
if($lat!==0 && $lon!==0 && strlen($fusrname)>0){
neutral_query('INSERT INTO '.$dbss['prfx']."_geoloc VALUES($id,'$fusrname',$lat,$lon,2100000000)");
}}

redirect('admin.php?q=users&ok='.$timestamp);}

/* --- */

if(isset($_POST['createuser']) && isset($_POST['ingroup'])){
$createuser=abc123a($_POST['createuser'],''); $ingroup=(int)$_POST['ingroup'];

$res=neutral_query('SELECT * FROM '.$dbss['prfx']."_users WHERE name='$createuser'");
if(neutral_num_rows($res)>0 || length($createuser)<3){redirect('admin.php?q=users');die();}
$randstr=rand_str(20);
$randpss=hash('sha256',$randstr.$timestamp);
$randmll=rand_str(10).'@mailinator.com';
$randqss='random-non-recoverable';
$randans=hash('sha256',$randqss.$timestamp);
neutral_query('INSERT INTO '.$dbss['prfx']."_users VALUES(NULL,$ingroup,'$createuser','$randpss','$randmll','','$randstr','127.0.0.1','$randqss','$randans',$timestamp,'')");
redirect('admin.php?q=users&ok='.$timestamp);}

/* --- */

if(isset($_POST['multimsg']) && is_array($_POST['multimsg']) && count($_POST['multimsg'])>0){
$multimsg=$_POST['multimsg'];
for($i=0;$i<count($multimsg);$i++){$multimsg[$i]=(int)$multimsg[$i];}
$dbinit=implode(',',$multimsg);
neutral_query('DELETE FROM '.$dbss['prfx']."_messages WHERE id IN ($dbinit)");
redirect('admin.php?q=messages&ok='.$timestamp); }

/* --- */

if(isset($_POST['multioff']) && is_array($_POST['multioff']) && count($_POST['multioff'])>0){
$multioff=$_POST['multioff'];
for($i=0;$i<count($multioff);$i++){$multioff[$i]=(int)$multioff[$i];}
$dbinit=implode(',',$multioff);
neutral_query('DELETE FROM '.$dbss['sprf']."_offmsg WHERE id IN ($dbinit)");
redirect('admin.php?q=msgoff&ok='.$timestamp); }

if(isset($_GET['deloldoffmsg'])){
$delpoint=(int)$_GET['deloldoffmsg'];
if($delpoint>0){$delpoint=$timestamp-($delpoint*86400);
neutral_query('DELETE FROM '.$dbss['sprf']."_offmsg WHERE timestamp<$delpoint");
redirect('admin.php?q=msgoff&ok='.$timestamp);}}

if(isset($_POST['helpdesk_usr']) && isset($_POST['helpdesk_desc'])){
$xx=neutral_escape($_POST['helpdesk_usr'],16,'str');
$yy=neutral_escape($_POST['helpdesk_desc'],64,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$xx' WHERE id='helpdesk_usr'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$yy' WHERE id='helpdesk_desc'");
redirect('admin.php?q=msgoff&ok='.$timestamp);}

/* --- */

if(isset($_POST['whattodo']) && isset($_POST['multiusers']) && is_array($_POST['multiusers']) && count($_POST['multiusers'])>0){

$multiusers=$_POST['multiusers'];
for($i=0;$i<count($multiusers);$i++){$multiusers[$i]=(int)$multiusers[$i];}
$dbinit=implode(',',$multiusers);

if($_POST['whattodo']=='1'){neutral_query('UPDATE '.$dbss['prfx']."_users SET vcode='' WHERE id IN ($dbinit)");}
if($_POST['whattodo']=='2'){

// del all avatars from array
$res=neutral_query('SELECT image FROM '.$dbss['sprf']."_uxtra WHERE id>1 AND id IN ($dbinit)");
while($row=neutral_fetch_array($res)){if($row['image']!='' && strpos($row['image'],$xpath_at_dir)===0){@unlink($row['image']);}}

neutral_query('DELETE FROM '.$dbss['prfx']."_users WHERE id>1 AND id IN ($dbinit)");
neutral_query('DELETE FROM '.$dbss['prfx']."_social WHERE userid IN ($dbinit)");
neutral_query('DELETE FROM '.$dbss['prfx']."_ufake WHERE id IN ($dbinit)");
neutral_query('DELETE FROM '.$dbss['prfx']."_geoloc WHERE id IN ($dbinit)");
neutral_query('DELETE FROM '.$dbss['sprf']."_uxtra WHERE id>1 AND id IN ($dbinit)");
} redirect('admin.php?q=users&ok='.$timestamp); }

/* --- */

if(isset($_POST['whattodo']) && isset($_POST['multifiles']) && is_array($_POST['multifiles']) && count($_POST['multifiles'])>0){

$multifiles=$_POST['multifiles'];
for($i=0;$i<count($multifiles);$i++){$multifiles[$i]=(int)$multifiles[$i];}
$dbinit=implode(',',$multifiles);
if($_POST['whattodo']=='1'){neutral_query('UPDATE '.$dbss['sprf']."_fmedia SET userid=0, username='(P)' WHERE id IN ($dbinit)");}
if($_POST['whattodo']=='3'){neutral_query('UPDATE '.$dbss['sprf']."_fmedia SET userid=-1, username='(H)' WHERE id IN ($dbinit)");}

if($_POST['whattodo']=='2'){
$res=neutral_query('SELECT file2hdd FROM '.$dbss['sprf']."_fmedia WHERE id IN ($dbinit)");
while($row=neutral_fetch_array($res)){ @unlink($row['file2hdd']); @unlink($row['file2hdd'].'.webp'); @unlink($row['file2hdd'].'.jpg');}
neutral_query('DELETE FROM '.$dbss['sprf']."_polls WHERE id IN ($dbinit)");
neutral_query('DELETE FROM '.$dbss['sprf']."_fmedia WHERE id IN ($dbinit)");
} redirect('admin.php?q=files&ok='.$timestamp); }

/* --- */

if(isset($_GET['deloldfiles'])){
$delpoint=(int)$_GET['deloldfiles'];
if($delpoint>0){
$delpoint=$timestamp-($delpoint*86400);

$res=neutral_query('SELECT id,file2hdd FROM '.$dbss['sprf']."_fmedia WHERE timestamp<$delpoint AND userid>0");
while($row=neutral_fetch_array($res)){ @unlink($row['file2hdd']); @unlink($row['file2hdd'].'.webp'); @unlink($row['file2hdd'].'.jpg');
neutral_query('DELETE FROM '.$dbss['sprf'].'_polls WHERE id='.$row['id']);}
neutral_query('DELETE FROM '.$dbss['sprf']."_fmedia WHERE timestamp<$delpoint AND userid>0");
redirect('admin.php?q=files&ok='.$timestamp);
}}

/* --- */

if(isset($_GET['deloldms'])){
$delpoint=(int)$_GET['deloldms'];
if($delpoint>0){$delpoint=$timestamp-($delpoint*86400);
neutral_query('DELETE FROM '.$dbss['prfx']."_messages WHERE timestamp<$delpoint AND id>1");
redirect('admin.php?q=messages&ok='.$timestamp);}}

/* --- */

if(isset($_POST['crn_k']) && isset($_POST['crn_m']) && isset($_POST['crn_p']) && isset($_POST['crn_d']) && isset($_POST['crn_u']) && isset($_POST['crn_q']) && isset($_POST['crn_g']) && isset($_POST['crn_o'])){

$crn_m=(int)$_POST['crn_m'];if($crn_m<1){$crn_m=20;}
$crn_p=(int)$_POST['crn_p'];if($crn_p<1){$crn_p=20;}
$crn_d=(int)$_POST['crn_d'];if($crn_d<1){$crn_d=20;}
$crn_u=(int)$_POST['crn_u'];if($crn_u<1){$crn_u=20;}
$crn_q=(int)$_POST['crn_q'];if($crn_q<1){$crn_q=20;}
$crn_g=(int)$_POST['crn_g'];if($crn_g>0){$crn_g=1;}else{$crn_g=0;}
$crn_o=(int)$_POST['crn_o'];if($crn_o>0){$crn_o=1;}else{$crn_o=0;}
$crn_k=abc123a($_POST['crn_k'],'');$crn_k=str_replace(' ','',$crn_k); $crn_k=neutral_escape($crn_k,40,'str');

neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$crn_m' WHERE id='crn_m'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$crn_p' WHERE id='crn_p'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$crn_d' WHERE id='crn_d'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$crn_u' WHERE id='crn_u'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$crn_q' WHERE id='crn_q'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$crn_g' WHERE id='crn_g'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$crn_o' WHERE id='crn_o'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$crn_k' WHERE id='crn_k'");

redirect('admin.php?q=dbopt&ok='.$timestamp);
}

/* --- */

if(isset($_POST['catid']) && isset($_POST['catname']) && isset($_POST['catenbl'])){
$catid=(int)$_POST['catid'];
$catnm=neutral_escape($_POST['catname'],128,'str');
if(strlen($catnm)<1){$catnm='Category';}
$caten=(int)$_POST['catenbl'];
neutral_query('UPDATE '.$dbss['sprf']."_qcats SET value='$catnm', enbl=$caten WHERE id=$catid");
redirect('admin.php?q=quizzes&ok='.$timestamp);
}

if(isset($_GET['delqcat'])){
$delqcat=(int)$_GET['delqcat'];
neutral_query('DELETE FROM '.$dbss['sprf']."_qcats WHERE id=$delqcat");
neutral_query('DELETE FROM '.$dbss['sprf']."_qdata WHERE catid=$delqcat");
redirect('admin.php?q=quizzes&ok='.$timestamp);
}

if(isset($_FILES['quizupload']) && isset($_FILES['quizupload']['name'])){
$quizname=explode('.',$_FILES['quizupload']['name']);
$quizname=neutral_escape($quizname[0],64,'str');
$quizdata=file($_FILES['quizupload']['tmp_name']);

neutral_query('INSERT INTO '.$dbss['sprf']."_qcats VALUES(NULL,'$quizname',0)");
$catid=neutral_query('SELECT MAX(id) FROM '.$dbss['sprf'].'_qcats');
$catid=neutral_fetch_array($catid);$catid=(int)$catid[0];

for($i=0;$i<count($quizdata);$i++){
$row=explode('|',trim($quizdata[$i]));

if(count($row)==6 && in_array(strtolower($row[5]),['a','b','c','d'])){
$q=neutral_escape($row[0],512,'txt');
$a1=neutral_escape($row[1],256,'txt');
$a2=neutral_escape($row[2],256,'txt');
$a3=neutral_escape($row[3],256,'txt');
$a4=neutral_escape($row[4],256,'txt');
$a5=neutral_escape(strtoupper($row[5]),1,'str');
neutral_query('INSERT INTO '.$dbss['sprf']."_qdata VALUES(NULL,$catid,'$q','$a1','$a2','$a3','$a4','$a5')");
}} redirect('admin.php?q=quizzes&ok='.$timestamp); }

/* --- */

if(isset($_POST['whattodo']) && isset($_POST['multipaint']) && is_array($_POST['multipaint']) && count($_POST['multipaint'])>0){

$multipaint=$_POST['multipaint']; $delhasharr=array();

for($i=0;$i<count($multipaint);$i++){$multipaint[$i]=(int)$multipaint[$i];
$delhasharr[]=$multipaint[$i].'z'.substr(sha1($multipaint[$i].'dood'.$settings['random_salt']),5,25);}

$dbinit=implode(',',$multipaint);
if($_POST['whattodo']=='1'){neutral_query('UPDATE '.$dbss['sprf']."_paintings SET userid=0, username='(P)' WHERE id IN ($dbinit)");}
if($_POST['whattodo']=='3'){neutral_query('UPDATE '.$dbss['sprf']."_paintings SET userid=-1, username='(H)' WHERE id IN ($dbinit)");}

if($_POST['whattodo']=='2'){
foreach($delhasharr as $value){@unlink($xpath_at_dir.'/dood_'.$value.'.png');}
neutral_query('DELETE FROM '.$dbss['sprf']."_paintings WHERE id IN ($dbinit)");
} redirect('admin.php?q=paint&ok='.$timestamp); }

/* --- */

if(isset($_GET['deloldpaint'])){
$delpoint=(int)$_GET['deloldpaint'];
if($delpoint>0){$delpoint=$timestamp-($delpoint*86400);

$res=neutral_query('SELECT id FROM '.$dbss['sprf']."_paintings WHERE timestamp<$delpoint AND userid>0");
while($row=neutral_fetch_array($res)){
$delhash=$row['id'].'z'.substr(sha1($row['id'].'dood'.$settings['random_salt']),5,25);
@unlink($xpath_at_dir.'/dood_'.$delhash.'.png');}

neutral_query('DELETE FROM '.$dbss['sprf']."_paintings WHERE timestamp<$delpoint AND userid>0");
redirect('admin.php?q=paint&ok='.$timestamp);
}}

/* --- */

if(isset($_GET['delguests'])){

$gs=array();
$res=neutral_query('SELECT id FROM '.$dbss['prfx'].'_users WHERE length(password)<1 AND id NOT IN (SELECT id FROM '.$dbss['prfx'].'_ufake)');
while($row=neutral_fetch_array($res)){ $gs[]=$row['id']; }

if(count($gs)>0){$gs=implode(',',$gs);

// del all avatars from array
$res=neutral_query('SELECT image FROM '.$dbss['sprf'].'_uxtra WHERE id>1 AND id IN ('.$gs.') AND id NOT IN (SELECT id FROM '.$dbss['prfx'].'_ufake)');
while($row=neutral_fetch_array($res)){if($row['image']!='' && strpos($row['image'],$xpath_at_dir)===0){@unlink($row['image']);}}

neutral_query('DELETE FROM '.$dbss['sprf']."_uxtra WHERE id IN ($gs)");}
neutral_query('DELETE FROM '.$dbss['prfx'].'_users WHERE length(password)<1 AND id NOT IN (SELECT id FROM '.$dbss['prfx'].'_ufake)');
neutral_query('DELETE FROM '.$dbss['prfx'].'_iplog');

redirect('admin.php?q=users&ok='.$timestamp);
}

/* --- */

if(isset($_GET['delfuser'])){
$delfuser=(int)$_GET['delfuser'];
neutral_query('DELETE FROM '.$dbss['prfx']."_ufake WHERE id=$delfuser");
neutral_query('DELETE FROM '.$dbss['prfx']."_geoloc WHERE id=$delfuser");
redirect('admin.php?q=fusers&ok='.$timestamp);
}

if(isset($_GET['delfake'])){
neutral_query('DELETE FROM '.$dbss['prfx']."_ufake");
neutral_query('DELETE FROM '.$dbss['prfx']."_geoloc WHERE timestamp=2100000000");
redirect('admin.php?q=fusers&ok='.$timestamp);
}

if(isset($_GET['uf_order'])){
$uf_order=(int)$_GET['uf_order'];
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$uf_order' WHERE id='uf_order'");
redirect('admin.php?q=fusers&ok='.$timestamp);
}

if(isset($_POST['hour_begin']) && isset($_POST['hour_end'])){
if(!isset($_POST['multifusers']) || !is_array($_POST['multifusers'])){redirect('admin.php?q=fusers&ok='.$timestamp);}
$hour_begin=(int)$_POST['hour_begin']; if($hour_begin<0 || $hour_begin>23){$hour_begin=0;}
$hour_end=(int)$_POST['hour_end']; if($hour_end<1 || $hour_end>24){$hour_end=24;}
if($hour_end==$hour_begin || $hour_end<$hour_begin){$hour_begin=0;$hour_end=24;}
if(isset($_POST['status'])){$status=(int)$_POST['status'];}else{$status=1;} if($status<1 || $status>5){$status=1;}
$multifusers=$_POST['multifusers'];
for($i=0;$i<count($multifusers);$i++){$multifusers[$i]=(int)$multifusers[$i];}
$dbinit=implode(',',$multifusers);
neutral_query('UPDATE '.$dbss['prfx']."_ufake SET status=$status, hour_begin=$hour_begin, hour_end=$hour_end WHERE id IN($dbinit)");
redirect('admin.php?q=fusers&ok='.$timestamp);
}

/* --- */

if(isset($_POST['editvip'])){
$vid=(int)$_POST['editvip'];
if(isset($_POST['name']) && strlen(trim($_POST['name']))>2){$name=neutral_escape($_POST['name'],40,'str');}else{$name='VIP #'.$vid;}
if(isset($_POST['vsign'])){$vsign=neutral_escape($_POST['vsign'],2,'str');}else{$vsign='★';}
neutral_query('UPDATE '.$dbss['prfx']."_vip SET name='$name',vsign='$vsign' WHERE id=$vid");
redirect('admin.php?q=vip&id='.$vid.'&ok='.$timestamp); }

if(isset($_GET['addvip'])){
$randstr=rand_str(64);
neutral_query('INSERT INTO '.$dbss['prfx']."_vip VALUES(NULL,'★','VIP','$randstr')");
redirect('admin.php?q=vips&ok='.$timestamp); }

if(isset($_GET['delvip'])){
$del=(int)$_GET['delvip'];
neutral_query('DELETE FROM '.$dbss['prfx'].'_vipusr WHERE vip='.$del);
neutral_query('DELETE FROM '.$dbss['prfx'].'_vip WHERE id='.$del);
redirect('admin.php?q=vips&ok='.$timestamp); }

if(isset($_GET['delvipentry']) && isset($_GET['rvip'])){
$rvp=(int)$_GET['rvip']; $token=neutral_escape($_GET['delvipentry'],10,'str');
neutral_query('UPDATE '.$dbss['prfx']."_vipusr SET expirestamp=0 WHERE token='$token'");
redirect('admin.php?q=vip&id='.$rvp.'&ok='.$timestamp);}

if(isset($_GET['delallvips'])){
$x=@base64_decode($_GET['delallvips']);
$x=explode(',',$x); for($i=0;$i<count($x);$i++){$x[$i]=(int)$x[$i];} 
if(count($x)>0){$x=implode(',',$x); neutral_query('DELETE FROM '.$dbss['prfx']."_vip WHERE id IN($x)");}
redirect('admin.php?q=vips&ok='.$timestamp); }

/* --- */

if($xuser['id']==1 && isset($_POST['stripe_apikey']) && isset($_POST['webhook_secret']) && isset($_POST['shuffle_items']) && isset($_POST['vipshop_info']) && isset($_POST['vipshop_title']) && isset($_POST['vipshop_theme']) && isset($_POST['success_msg']) && isset($_POST['cancel_msg']) && isset($_POST['missing_msg'])){

$stripe_apikey=neutral_escape($_POST['stripe_apikey'],200,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$stripe_apikey' WHERE id='stripe_apikey'");

$webhook_secret=neutral_escape($_POST['webhook_secret'],200,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$webhook_secret' WHERE id='webhook_secret'");

$shuffle_items=(int)$_POST['shuffle_items'];
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$shuffle_items' WHERE id='shuffle_items'");

$vipshop_info=neutral_escape($_POST['vipshop_info'],2500,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vipshop_info' WHERE id='vipshop_info'");

$vipshop_theme=substr(abc123a($_POST['vipshop_theme'],''),0,50);
if(is_file('./vipshop/themes/'.$vipshop_theme.'/item.template')){
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vipshop_theme' WHERE id='vipshop_theme'");}

$vipshop_title=neutral_escape($_POST['vipshop_title'],200,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vipshop_title' WHERE id='vipshop_title'");

$success_msg=neutral_escape($_POST['success_msg'],2500,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$success_msg' WHERE id='success_msg'");

$cancel_msg=neutral_escape($_POST['cancel_msg'],2500,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$cancel_msg' WHERE id='cancel_msg'");

$missing_msg=neutral_escape($_POST['missing_msg'],2500,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$missing_msg' WHERE id='missing_msg'");

redirect('admin.php?q=vipshop&ok='.$timestamp); }


if(isset($_POST['vipslot']) && isset($_POST['vipname']) && isset($_POST['hours'])){
$vipslot=(int)$_POST['vipslot'];
$hours=(int)$_POST['hours'];
$vipname=neutral_escape($_POST['vipname'],40,'str');
neutral_query('INSERT INTO '.$dbss['prfx']."_vproducts VALUES(NULL,$vipslot,'$vipname','',$hours,'','',0)");
redirect('admin.php?q=vipshop&ok='.$timestamp); }

if(isset($_GET['delvproduct'])){
$del=(int)$_GET['delvproduct'];
neutral_query('DELETE FROM '.$dbss['prfx'].'_vproducts WHERE id='.$del);
redirect('admin.php?q=vipshop&ok='.$timestamp); }

if(isset($_POST['vipshopid'])){
$vshopid=$_POST['vipshopid'];

if(isset($_POST['name'])){$name=neutral_escape($_POST['name'],64,'str');}
if(!isset($name) || strlen($name)<1){$name='PRODUCT #'.$vshopid;}
if(isset($_POST['vdesc'])){$vdesc=neutral_escape($_POST['vdesc'],600,'txt');}else{$vdesc='';}
if(isset($_POST['vlength'])){$vlength=(int)$_POST['vlength'];}else{$vlength=0;}
if(isset($_POST['vipslot'])){$vipslot=(int)$_POST['vipslot'];}else{$vipslot=0;}
if(isset($_POST['stripepriceid'])){$stripepriceid=neutral_escape($_POST['stripepriceid'],64,'str');}else{$stripepriceid='';}
if(isset($_POST['infoprice'])){$infoprice=neutral_escape($_POST['infoprice'],10,'str');}else{$infoprice='';}
if(isset($_POST['zorder'])){$zorder=(int)$_POST['zorder'];}else{$zorder=0;}

if($vlength>0 && $vipslot>0){
neutral_query('UPDATE '.$dbss['prfx']."_vproducts SET name='$name', vdesc='$vdesc', vlength=$vlength, vipid=$vipslot, stripepriceid='$stripepriceid', infoprice='$infoprice', zorder='$zorder' WHERE id=$vshopid");}

redirect('admin.php?q=vshopid&id='.$vshopid.'&ok='.$timestamp); }

/* --- */

if(isset($_GET['verifytype'])){ $vrf=(int)$_GET['verifytype'];
if($vrf==0 || ($vrf>0 && $vrf<3)){neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vrf' WHERE id='verify'");}
redirect('admin.php?q=verify&ok='.$timestamp);}


if(isset($_POST['verify_subj']) && isset($_POST['verify_mssg']) && isset($_POST['preset_subj']) && isset($_POST['preset_mssg']) ){

$verify_subj=neutral_escape($_POST['verify_subj'],100,'str');
$preset_subj=neutral_escape($_POST['preset_subj'],100,'str');
$verify_mssg=neutral_escape($_POST['verify_mssg'],320,'str');
$preset_mssg=neutral_escape($_POST['preset_mssg'],320,'str');

neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$verify_subj' WHERE id='verify_subj'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$preset_subj' WHERE id='preset_subj'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$verify_mssg' WHERE id='verify_mssg'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$preset_mssg' WHERE id='preset_mssg'");

redirect('admin.php?q=verify&ok='.$timestamp);}


if(isset($_POST['vcs_cs_usr']) && isset($_POST['vcs_cs_key']) && isset($_POST['vcs_sender']) && isset($_POST['vcs_whitelist']) && isset($_POST['vcs_blacklist'])){

$vcs_cs_usr=neutral_escape($_POST['vcs_cs_usr'],100,'str');
$vcs_cs_key=neutral_escape($_POST['vcs_cs_key'],100,'str');
$vcs_sender=neutral_escape($_POST['vcs_sender'],11,'str');
$vcs_blacklist=neutral_escape($_POST['vcs_blacklist'],100,'str');
$vcs_whitelist=array(); $vcs_templist=explode(',',$_POST['vcs_whitelist']); for($i=0;$i<count($vcs_templist);$i++){
$tt=(int)$vcs_templist[$i]; if($tt>0){$vcs_whitelist[]=$tt;}} 

$vcs_whitelist=implode(',',$vcs_whitelist);

if($xuser['id']==1){
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vcs_cs_usr' WHERE id='vcs_cs_usr'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vcs_cs_key' WHERE id='vcs_cs_key'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vcs_sender' WHERE id='vcs_sender'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vcs_whitelist' WHERE id='vcs_whitelist'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vcs_blacklist' WHERE id='vcs_blacklist'");
}

redirect('admin.php?q=verify&ok='.$timestamp);}


if(isset($_POST['vpm_smtp_host']) && isset($_POST['vpm_smtp_user']) && isset($_POST['vpm_smtp_pass']) && isset($_POST['vpm_smtp_from']) && isset($_POST['vpm_smtp_auth']) && isset($_POST['vpm_smtp_secu']) && isset($_POST['vpm_smtp_port']) && isset($_POST['vpm_smtp_mail']) && isset($_POST['vpm_smtp_more']) && isset($_POST['vpm_blacklist']) && isset($_POST['vpm_passreset']) ){

$vpm_smtp_host=neutral_escape($_POST['vpm_smtp_host'],100,'str');
$vpm_smtp_user=neutral_escape($_POST['vpm_smtp_user'],100,'str');
$vpm_smtp_pass=neutral_escape($_POST['vpm_smtp_pass'],100,'str');
$vpm_smtp_from=neutral_escape($_POST['vpm_smtp_from'],100,'str');
$vpm_smtp_auth=neutral_escape($_POST['vpm_smtp_auth'],5,'str');
$vpm_smtp_secu=neutral_escape($_POST['vpm_smtp_secu'],9,'str');
$vpm_smtp_port=neutral_escape($_POST['vpm_smtp_port'],5,'int');
$vpm_smtp_mail=neutral_escape($_POST['vpm_smtp_mail'],100,'str'); if(strlen($vpm_smtp_mail)<1){$vpm_smtp_mail='0';}
$vpm_smtp_more=neutral_escape($_POST['vpm_smtp_more'],200,'str');
$vpm_blacklist=neutral_escape($_POST['vpm_blacklist'],100,'str');
$vpm_passreset=(int)$_POST['vpm_passreset']; if($vpm_passreset>1 || $vpm_passreset<0){$vpm_passreset=0;}

if($xuser['id']==1){
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vpm_smtp_host' WHERE id='vpm_smtp_host'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vpm_smtp_user' WHERE id='vpm_smtp_user'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vpm_smtp_pass' WHERE id='vpm_smtp_pass'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vpm_smtp_from' WHERE id='vpm_smtp_from'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vpm_smtp_auth' WHERE id='vpm_smtp_auth'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vpm_smtp_secu' WHERE id='vpm_smtp_secu'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vpm_smtp_port' WHERE id='vpm_smtp_port'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vpm_smtp_mail' WHERE id='vpm_smtp_mail'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vpm_smtp_more' WHERE id='vpm_smtp_more'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vpm_blacklist' WHERE id='vpm_blacklist'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vpm_passreset' WHERE id='vpm_passreset'");
}

redirect('admin.php?q=verify&ok='.$timestamp);}

/* --- */

if(isset($_POST['acpreadonly'])){
$readonly=(int)$_POST['acpreadonly'];
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$readonly' WHERE id='acpreadonly'");
redirect('admin.php?q=groups&ok='.$timestamp); }

if(isset($_GET['addgroup'])){
neutral_query('INSERT INTO '.$dbss['prfx']."_groups VALUES(NULL,'NEW GROUP','',0,0,'FEC400',1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,1,1,1,0,1,0)");
redirect('admin.php?q=groups&ok='.$timestamp); }

if(isset($_GET['delgroup'])){
$del=(int)$_GET['delgroup'];
if($del>1){neutral_query('DELETE FROM '.$dbss['prfx'].'_groups WHERE id='.$del);
redirect('admin.php?q=groups&ok='.$timestamp); }}

if(isset($_GET['addroom'])){
$zcolor=array('E91E63','673AB7','8BC34A','FFC107','3F51B5','C0CA33','1E88E5','607D8B','009688','E53935');
$k=array_rand($zcolor); $zcolor=$zcolor[$k];$zorder=substr($timestamp,-4);if($zorder<1000){$zorder+=1000;}
neutral_query('INSERT INTO '.$dbss['prfx']."_rooms VALUES(NULL,'NEW ROOM','Description...','$zcolor',$zorder,0,'')");
redirect('admin.php?q=rooms&ok='.$timestamp); }

if(isset($_GET['delroom'])){
$del=(int)$_GET['delroom'];
if($del>1){neutral_query('DELETE FROM '.$dbss['prfx'].'_rooms WHERE id='.$del);
redirect('admin.php?q=rooms&ok='.$timestamp); }}

if(isset($_GET['delallrooms'])){
neutral_query('DELETE FROM '.$dbss['prfx'].'_rooms WHERE id>1');
redirect('admin.php?q=rooms&ok='.$timestamp); }

/* --- */

if(isset($_POST['showroombg']) && isset($_POST['roombgc']) && isset($_POST['roombgf']) && isset($_POST['roombgt']) && isset($_POST['roombgs']) && isset($_POST['roombgl'])){  

$showroombg=(int)$_POST['showroombg'];   
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$showroombg' WHERE id='showroombg'");

$roombgc=stripc($_POST['roombgc']);
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$roombgc' WHERE id='roombgc'");

$roombgf=strtolower($_POST['roombgf']);
if( !in_array($roombgf, array('serif','sans-serif','monospace'))){$roombgf='serif';}
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$roombgf' WHERE id='roombgf'");

$roombgt=(int)$_POST['roombgt'];
if($roombgt<10 || $roombgt>100){$roombgt=10;}
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$roombgt' WHERE id='roombgt'");

$roombgs=(int)$_POST['roombgs'];
if($roombgs<20 || $roombgs>120){$roombgs=90;}
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$roombgs' WHERE id='roombgs'");

$roombgl=(int)$_POST['roombgl'];
if($roombgl<5 || $roombgl>30){$roombgl=8;}
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$roombgl' WHERE id='roombgl'");

redirect('admin.php?q=rooms&ok='.$timestamp);
}

/* --- */

if(isset($_POST['editroom'])){
$rid=(int)$_POST['editroom'];
if(isset($_POST['name']) && strlen(trim($_POST['name']))>2){$name=neutral_escape($_POST['name'],40,'str');}else{$name='ROOM #'.$rid;}
if(isset($_POST['desc'])){$desc=neutral_escape($_POST['desc'],80,'str');}else{$desc='';}
if(isset($_POST['color'])){$color=stripc($_POST['color']);}else{$color='666';}
if(isset($_POST['hidden'])){$hidden=(int)$_POST['hidden'];}else{$hidden=0;} 
if(isset($_POST['zorder'])){$zorder=(int)$_POST['zorder'];}else{$zorder=1001;} 
if($zorder<1000){$zorder+=1000;} if($rid==1){$zorder=0;}

$rgroups=array();
if(isset($_POST['groups']) && is_array($_POST['groups']) && $hidden>0){
for($i=0;$i<count($_POST['groups']);$i++){
$rgroups[]=(int)$_POST['groups'][$i];}}
$rgroups=implode(',',$rgroups);
if($rid<2){$hidden=0;$rgroups='';}

neutral_query('UPDATE '.$dbss['prfx']."_rooms SET name='$name',description='$desc',color='$color',zorder=$zorder,hidden=$hidden,groupids='$rgroups' WHERE id=$rid");

redirect('admin.php?q=rooms&ok='.$timestamp);
}

if(isset($_POST['editgroup'])){
$gid=(int)$_POST['editgroup'];
if(isset($_POST['name']) && strlen(trim($_POST['name']))>2){$name=neutral_escape($_POST['name'],64,'str');}else{$name='g'.$gid;}

if(isset($_POST['welcome'])){
$welcome=@base64_decode($_POST['welcome']);
$welcome=str_replace("'",'',$welcome); 
$welcome=str_replace("\r",'',$welcome); 
$welcome=str_replace("\n",' ',$welcome); 
$welcome=neutral_escape($welcome,2048,'txt');}

if(isset($_POST['link'])){$link=(int)$_POST['link'];}else{$link=0;}
if(isset($_POST['vlnk'])){$vlnk=(int)$_POST['vlnk'];}else{$vlnk=0;}
if($vlnk>0){$link=0;}
if(isset($_POST['color'])){$color=stripc($_POST['color']);}else{$color='666';}
if(isset($_POST['pa'])){$pa=(int)$_POST['pa'];}else{$pa=1;}
if(isset($_POST['pb'])){$pb=(int)$_POST['pb'];}else{$pb=1;}
if(isset($_POST['pc'])){$pc=(int)$_POST['pc'];}else{$pc=0;} if($vlnk>0){$pc=0;}
if(isset($_POST['pd'])){$pd=(int)$_POST['pd'];}else{$pd=0;} //if($vlnk>0){$pd=0;}
if(isset($_POST['pe'])){$pe=(int)$_POST['pe'];}else{$pe=0;}
if(isset($_POST['pf'])){$pf=(int)$_POST['pf'];}else{$pf=1;}
if(isset($_POST['pg'])){$pg=(int)$_POST['pg'];}else{$pg=1;}
if(isset($_POST['ph'])){$ph=(int)$_POST['ph'];}else{$ph=1;}
if(isset($_POST['pi'])){$pi=(int)$_POST['pi'];}else{$pi=1;}
if(isset($_POST['pj'])){$pj=(int)$_POST['pj'];}else{$pj=1;}
if(isset($_POST['pk'])){$pk=(int)$_POST['pk'];}else{$pk=1;}
if(isset($_POST['pl'])){$pl=(int)$_POST['pl'];}else{$pl=1;}
if(isset($_POST['pm'])){$pm=(int)$_POST['pm'];}else{$pm=1;}
if(isset($_POST['pn'])){$pn=(int)$_POST['pn'];}else{$pn=1;}
if(isset($_POST['po'])){$po=(int)$_POST['po'];}else{$po=1;}
if(isset($_POST['pp'])){$pp=(int)$_POST['pp'];}else{$pp=1;}
if(isset($_POST['pq'])){$pq=(int)$_POST['pq'];}else{$pq=1;}
if(isset($_POST['pr'])){$pr=(int)$_POST['pr'];}else{$pr=1;}
if(isset($_POST['ps'])){$ps=(int)$_POST['ps'];}else{$ps=1;}
if(isset($_POST['pt'])){$pt=(int)$_POST['pt'];}else{$pt=1;}
if(isset($_POST['pu'])){$pu=(int)$_POST['pu'];}else{$pu=1;}
if(isset($_POST['pv'])){$pv=(int)$_POST['pv'];}else{$pv=1;}
if(isset($_POST['pw'])){$pw=(int)$_POST['pw'];}else{$pw=1;}
if(isset($_POST['px'])){$px=(int)$_POST['px'];}else{$px=1;}
if(isset($_POST['py'])){$py=(int)$_POST['py'];}else{$py=1;}
if(isset($_POST['pz'])){$pz=(int)$_POST['pz'];}else{$pz=1;}

neutral_query('UPDATE '.$dbss['prfx']."_groups SET name='$name',welcome='$welcome',color='$color',link=$link,vlnk=$vlnk,pa=$pa,pb=$pb,pc=$pc,pd=$pd,pe=$pe,pf=$pf,pg=$pg,ph=$ph,pi=$pi,pj=$pj,pk=$pk,pl=$pl,pm=$pm,pn=$pn,po=$po,pp=$pp,pq=$pq,pr=$pr,ps=$ps,pt=$pt,pu=$pu,pv=$pv,pw=$pw,px=$px,py=$py,pz=$pz WHERE id=$gid"); 

redirect('admin.php?q=groups&ok='.$timestamp);
}
/* --- */

if(isset($_POST['ctab_display'])){
if(isset($_POST['ctab_display'])){  $x=neutral_escape($_POST['ctab_display'],1,'int'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='ctab_display'");}
if(isset($_POST['ctab_default'])){  $x=neutral_escape($_POST['ctab_default'],1,'int'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='ctab_default'");}
if(isset($_POST['ctab_icon'])){     $x=neutral_escape($_POST['ctab_icon'],64,'str'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='ctab_icon'");}
if(isset($_POST['ctab_title'])){    $x=neutral_escape($_POST['ctab_title'],16,'str'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='ctab_title'");}
if(isset($_POST['ctab_content'])){  $x=@base64_decode($_POST['ctab_content']);$x=neutral_escape($x,32000,'txt'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='ctab_content'");}
redirect('admin.php?q=ctab&ok='.$timestamp);}

/* --- */

if(isset($_POST['announce'])){
if(isset($_POST['customhlrp'])){  $x=@base64_decode($_POST['customhlrp']); $x=neutral_escape($x,32000,'txt'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='customhlrp'");}
if(isset($_POST['tips_login'])){  $x=@base64_decode($_POST['tips_login']);$x=neutral_escape($x,32000,'txt'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='tips_login'");}
if(isset($_POST['tips_reg'])){    $x=@base64_decode($_POST['tips_reg']);  $x=neutral_escape($x,32000,'txt'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='tips_reg'");}
if(isset($_POST['tips_pass'])){   $x=@base64_decode($_POST['tips_pass']); $x=neutral_escape($x,32000,'txt'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='tips_pass'");}

$x=@base64_decode($_POST['announce']); $x=neutral_escape($x,32000,'txt'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='announce'");

redirect('admin.php?q=tips&ok='.$timestamp);}

/* --- */

if(isset($_POST['landing_header'])){
if(isset($_POST['landing_header'])){  $x=@base64_decode($_POST['landing_header']);$x=neutral_escape($x,32000,'txt'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='landing_header'");}
if(isset($_POST['landing_footer'])){  $x=@base64_decode($_POST['landing_footer']);$x=neutral_escape($x,32000,'txt'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='landing_footer'");}
redirect('admin.php?q=landing&ok='.$timestamp);}

/* --- */

if(isset($_POST['ptop'])){
$x=@base64_decode($_POST['ptop']); $x=neutral_escape($x,32000,'txt');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='ptop'");
redirect('admin.php?q=ptop&ok='.$timestamp);}

/* --- */

if(isset($_POST['stopwords'])){
$tempwords=explode(',',$_POST['stopwords']);
$stopwords=array();
for($i=0;$i<count($tempwords);$i++){
$stword=trim(str_replace(["\r","\n"],'',$tempwords[$i]));
if(strlen($stword)>2){$stopwords[]=$stword;}}
$stopwords=implode(',',$stopwords);
$stopwords=neutral_escape($stopwords,32000,'txt');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$stopwords' WHERE id='stopwords'");
redirect('admin.php?q=machines&ok='.$timestamp);}

/* --- */

if(isset($_POST['w_cache'])){
if(isset($_POST['w_cache'])){  $x=(int)$_POST['w_cache']; if($x<10 || $x>3600){$x=120;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='w_cache'");}
if(isset($_POST['w_cross'])){  $x=(int)$_POST['w_cross']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='w_cross'");}
if(isset($_POST['w_onlu'])){  $x=(int)$_POST['w_onlu']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='w_onlu'");}
if(isset($_POST['w_onla'])){  $x=(int)$_POST['w_onla']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='w_onla'");}
if(isset($_POST['w_stat'])){  $x=(int)$_POST['w_stat']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='w_stat'");}
if(isset($_POST['w_tten'])){  $x=(int)$_POST['w_tten']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='w_tten'");}
if(isset($_POST['w_last'])){  $x=(int)$_POST['w_last']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='w_last'");}

redirect('admin.php?q=widgets&ok='.$timestamp);}

/* --- */

if(isset($_POST['html_title'])){

if(isset($_POST['unl_timeout'])){  $x=(int)$_POST['unl_timeout']; if($x>3600){$x=3600;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='unl_timeout'");}
if(isset($_POST['rmb_unsent'])){   $x=neutral_escape($_POST['rmb_unsent'],1,'int'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='rmb_unsent'");}
if(isset($_POST['acp_css'])){      $x=neutral_escape($_POST['acp_css'],1,'int'); $x.='.css';  neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='acp_css'");}
if(isset($_POST['html_title'])){   $x=neutral_escape($_POST['html_title'],512,'str');  neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='html_title'");}
if(isset($_POST['cookie_salt'])){  $x=neutral_escape($_POST['cookie_salt'],64,'str');  neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='cookie_salt'");}
if(isset($_POST['default_lang'])){ $x=neutral_escape($_POST['default_lang'],2,'int');  neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='default_lang'");}
if(isset($_POST['default_ampm'])){ $x=neutral_escape($_POST['default_ampm'],1,'int');  neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='default_ampm'");}
if(isset($_POST['default_sound'])){$x=neutral_escape($_POST['default_sound'],1,'int'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='default_sound'");}
if(isset($_POST['allow_guest'])){  $x=neutral_escape($_POST['allow_guest'],1,'int');   neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='allow_guest'");}
if(isset($_POST['dimonblur'])){    $x=neutral_escape($_POST['dimonblur'],1,'int');     neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='dimonblur'");}
if(isset($_POST['allow_reg'])){    $x=neutral_escape($_POST['allow_reg'],1,'int');     neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='allow_reg'");}
if(isset($_POST['multiavatar'])){    $x=neutral_escape($_POST['multiavatar'],1,'int'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='multiavatar'");}
if(isset($_POST['keepiplg'])){     $x=neutral_escape($_POST['keepiplg'],9,'int'); if($x<86400){$x=86400;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='keepiplg'");}
if(isset($_POST['post_interval'])){$x=neutral_escape($_POST['post_interval'],3,'int'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='post_interval'");}
if(isset($_POST['userperhour'])){  $x=neutral_escape($_POST['userperhour'],3,'int');  if($x<1){$x=1;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='userperhour'");}
if(isset($_POST['wrongperhour'])){ $x=neutral_escape($_POST['wrongperhour'],3,'int'); if($x<1){$x=1;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='wrongperhour'");}
if(isset($_POST['ban_period'])){   $x=neutral_escape($_POST['ban_period'],9,'int'); if($x<3600 || $x>31536000){$x=7200;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='ban_period'");}
if(isset($_POST['mute_period'])){   $x=neutral_escape($_POST['mute_period'],9,'int'); if($x<60 || $x>86400){$x=300;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='mute_period'");}
if(isset($_POST['acp_offset'])){   $x=neutral_escape($_POST['acp_offset'],5,'int');  neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='acp_offset'");}
if(isset($_POST['welcome_msg'])){  $x=@base64_decode($_POST['welcome_msg']); $x=str_replace("'",'',$x); $x=str_replace("\r",'',$x); $x=str_replace("\n",' ',$x); $x=neutral_escape($x,2048,'txt'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='welcome_msg'");}
if(isset($_POST['mottos'])){  $x=stripslashes($_POST['mottos']); $x=str_replace("|",'',$x); $x=str_replace("\r",'',$x); $x=explode("\n",$x); $x=implode('|',$x); $x=neutral_escape($x,32000,'txt'); if(strlen($x)<5){$x='Motto?';} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='mottos'");}
if(isset($_POST['drag2scroll'])){  $x=neutral_escape($_POST['drag2scroll'],1,'int');   neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='drag2scroll'");}
if(isset($_POST['whee2scroll'])){  $x=neutral_escape($_POST['whee2scroll'],1,'int');   neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='whee2scroll'");}
if(isset($_POST['badge_txt'])){  $x=neutral_escape($_POST['badge_txt'],32,'str'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='badge_txt'");}
if(isset($_POST['badge_bgc'])){  $x=stripc($_POST['badge_bgc']); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='badge_bgc'");}
if(isset($_POST['pmlog_stop'])){ $x=(int)$_POST['pmlog_stop']; if($x<3600 || $x>2000000){$x=86400;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='pmlog_stop'");}
if(isset($_POST['tns_length'])){ $x=(int)$_POST['tns_length']; if($x<20 || $x>2000){$x=200;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='tns_length'");}
if(isset($_POST['tns_lowprv'])){ $x=(int)$_POST['tns_lowprv']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='tns_lowprv'");}
if(isset($_POST['meta_ref'])){ $x=neutral_escape($_POST['meta_ref'],20,'str'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='meta_ref'");}
if(isset($_POST['show_thumbs'])){$x=$_POST['show_thumbs']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='show_thumbs'");}
if(isset($_POST['ip2c'])){ $x=neutral_escape($_POST['ip2c'],2,'str'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='ip2c'");}
if(isset($_POST['clearscreen'])){ $x=abc123($_POST['clearscreen'],''); if(strlen($x)<8){$x='';} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='clearscreen'");}
if(isset($_POST['ip2hash'])){ $x=(int)$_POST['ip2hash']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='ip2hash'");}
if(isset($_POST['offmsg_del'])){ $x=(int)$_POST['offmsg_del']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='offmsg_del'");}

if(isset($_POST['pholders'])){ $x=neutral_escape($_POST['pholders'],32000,'txt'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='pholders'");}

if(isset($_POST['defaultsnip'])){ $x=neutral_escape($_POST['defaultsnip'],32000,'txt'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='defaultsnip'");}

if(isset($_POST['rqhints'])){ $x=neutral_escape($_POST['rqhints'],32000,'txt'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='rqhints'");}

if(isset($_POST['rsz_emoji'])){ $x=(int)$_POST['rsz_emoji']; if($x<100 || $x>200){$x=100;}
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='rsz_emoji'");}

redirect('admin.php?q=general&ok='.$timestamp);}

/* --- */

if(isset($_POST['force_av']) && isset($_POST['genderedit'])){

if(isset($_POST['force_av'])){ $x=(int)$_POST['force_av']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='force_av'");}
if(isset($_POST['genderedit'])){ $x=(int)$_POST['genderedit']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='genderedit'");}

if(isset($_POST['genderlist'])){
$y=array();$x=explode(',',$_POST['genderlist']);
foreach ($x as $key => $value) {$x[$key]=abc123a($x[$key],''); if(strlen($x[$key])>0){$y[]=$x[$key];}}
$x=implode(',',$y); $x=neutral_escape($x,32000,'txt'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='genderlist'");}

if(isset($_POST['avsize'])){       $x=(int)$_POST['avsize']; if($x<80 || $x>512){$x=250;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='avsize'");}
if(isset($_POST['avatar_msize'])){ $x=neutral_escape($_POST['avatar_msize'],9,'int'); if($x<102400){$x=102400;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='avatar_msize'");}
if(isset($_POST['file_msize'])){ $x=neutral_escape($_POST['file_msize'],9,'int'); if($x<102400){$x=102400;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='file_msize'");}
if(isset($_POST['uploads_user'])){ $x=neutral_escape($_POST['uploads_user'],9,'int'); if($x<1){$x=1;} if($x>100){$x=10;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='uploads_user'");}
if(isset($_POST['paintings_user'])){ $x=neutral_escape($_POST['paintings_user'],9,'int'); if($x<1){$x=1;} if($x>100){$x=10;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='paintings_user'");}
if(isset($_POST['mailchange'])){ $x=neutral_escape($_POST['mailchange'],8,'int'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='mailchange'");}

if(isset($_POST['profile_templt'])){
$x=@base64_decode($_POST['profile_templt']); $x=neutral_escape($x,32000,'str');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='profile_templt'");}

if(isset($_POST['profile_covers'])){
$x=@base64_decode($_POST['profile_covers']); $x=neutral_escape($x,32000,'txt');
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='profile_covers'");}

redirect('admin.php?q=profiles&ok='.$timestamp);}

/* --- */

if(isset($_POST['badwords']) && isset($_POST['badrepls'])){

$bw=array(); $x=str_replace("\r",'',$_POST['badwords']); $x=explode("\n",$x);
foreach ($x as $key => $value) {$x[$key]=abc123($x[$key],''); if(strlen($x[$key])>2){$bw[]=$x[$key];}else{$bw[]='Invalid Item';}}

$br=array(); $x=str_replace("\r",'',$_POST['badrepls']); $x=explode("\n",$x);
foreach ($x as $key => $value) {$x[$key]=abc123($x[$key],''); if(strlen($x[$key])>2){$br[]=$x[$key];}else{$br[]='***';}}

if(count($bw)>count($br)){$bw=array_splice($bw,0,count($br));}
if(count($br)>count($bw)){$br=array_splice($br,0,count($bw));}

$bw=implode(',',$bw); $bw=neutral_escape($bw,32000,'txt');
$br=implode(',',$br); $br=neutral_escape($br,32000,'txt');

if($bw=='Invalid Item' && $br=='***'){$bw='';$br='';}

neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$bw' WHERE id='badwords'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$br' WHERE id='badrepls'");

redirect('admin.php?q=badwords&ok='.$timestamp);}

/* --- */

if(isset($_POST['pg_on']) && function_exists('curl_init')){

if(isset($_POST['pg_on'])){ $x=(int)$_POST['pg_on']; neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='pg_on'");}
if(isset($_POST['pg_timeout'])){ $x=(int)$_POST['pg_timeout']; if($x<2 || $x>9){$x=5;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='pg_timeout'");}
if(isset($_POST['pg_tcache'])){ $x=(int)$_POST['pg_tcache']; if($x<7200 || $x>604800){$x=86400;} neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='pg_tcache'");}
if(isset($_POST['pg_api_src'])){ $x=neutral_escape($_POST['pg_api_src'],64,'str'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='pg_api_src'");}
if(isset($_POST['pg_api_key'])){ $x=neutral_escape($_POST['pg_api_key'],64,'str'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='pg_api_key'");}
if(isset($_POST['pg_failmsg'])){ $x=@base64_decode($_POST['pg_failmsg']);$x=neutral_escape($x,512,'str'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='pg_failmsg'");}
if(isset($_POST['pg_wlist'])){ $x=neutral_escape($_POST['pg_wlist'],32000,'str'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='pg_wlist'");}

redirect('admin.php?q=pguard&ok='.$timestamp);}

/* --- */

if(isset($_POST['intg_bbcms'])){

if(isset($_POST['intg_bbcms'])){ $x=neutral_escape($_POST['intg_bbcms'],64,'str');   neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='intg_bbcms'");}
if(isset($_POST['intg_cookie'])){$x=neutral_escape($_POST['intg_cookie'],64,'str');  neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='intg_cookie'");}
if(isset($_POST['intg_prefix'])){$x=neutral_escape($_POST['intg_prefix'],64,'str');  neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='intg_prefix'");}
if(isset($_POST['intg_logout'])){$x=neutral_escape($_POST['intg_logout'],64,'str');  neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='intg_logout'");}
if(isset($_POST['intg_nolog'])){ $x=neutral_escape($_POST['intg_nolog'],64,'str');   neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='intg_nolog'");}
if(isset($_POST['intg_pflink'])){ $x=neutral_escape($_POST['intg_pflink'],128,'str');   neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='intg_pflink'");}
if(isset($_POST['appcodesc'])){ $x=@base64_decode($_POST['appcodesc']);$x=neutral_escape($x,1024,'str'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='appcodesc'");}
if(isset($_POST['allow_guest'])){  $x=neutral_escape($_POST['allow_guest'],1,'int');   neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='allow_guest'");}
if(isset($_POST['allow_reg'])){    $x=neutral_escape($_POST['allow_reg'],1,'int');     neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='allow_reg'");}
if(isset($_POST['appcode'])){    $x=neutral_escape($_POST['appcode'],1,'int');         neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='appcode'");}
redirect('admin.php?q=integra&ok='.$timestamp);}

/* --- */

if(isset($_GET['dimport'])){
$query='DELETE FROM '.$dbss['prfx']."_groups WHERE id>1 AND link>0";
neutral_query($query);

$whattodo='getgroups';include 'ext/'.$settings['intg_bbcms'].'.php';

for($i=0;$i<9999;$i++){
if(isset($groups2import[$i])){
$addgroup=neutral_escape($groups2import[$i],64,'str');
$query='INSERT INTO '.$dbss['prfx']."_groups VALUES(NULL,'$addgroup','',$i,0,'FF5722',1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,1,1,1,0,1,0)";
neutral_query($query);}} 

redirect('admin.php?q=groups&ok='.$timestamp);}

/* --- */

if(isset($_POST['customjs']) && isset($_POST['bottomjs']) && isset($_POST['customhchat'])){
$x=@base64_decode($_POST['customjs']); $x=neutral_escape($x,32000,'txt'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='customjs'");
$x=@base64_decode($_POST['bottomjs']); $x=neutral_escape($x,32000,'txt'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='bottomjs'");
$x=@base64_decode($_POST['customhchat']); $x=neutral_escape($x,32000,'txt'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='customhchat'");
redirect('admin.php?q=customjs&ok='.$timestamp);}

/* --- */

if(isset($_POST['multi_links'])){
$x=@base64_decode($_POST['multi_links']); $x=neutral_escape($x,32000,'txt'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='multi_links'");

if(isset($_POST['badge_txt'])){  $x=neutral_escape($_POST['badge_txt'],32,'str'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='badge_txt'");}
if(isset($_POST['badge_bgc'])){  $x=stripc($_POST['badge_bgc']); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='badge_bgc'");}

redirect('admin.php?q=mlinks&ok='.$timestamp);}

/* --- */

if(isset($_POST['gifs_key']) && isset($_POST['gifs_num']) && isset($_POST['gifs_rnd'])){

$x=neutral_escape($_POST['gifs_key'],60,'str'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='gifs_key'");

$x=(int)$_POST['gifs_num']; if($x<5 || $x>30){$x=15;} 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='gifs_num'");

$x=neutral_escape($_POST['gifs_rnd'],1024,'str'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='gifs_rnd'");


redirect('admin.php?q=gifs&ok='.$timestamp);}

/* --- */

if(isset($_POST['utf8_run']) && isset($_POST['utf8_msg'])){

if(!isset($_POST['utf8_set']) || !is_array($_POST['utf8_set']) || count($_POST['utf8_set'])<1){
$utf8_set='Latin';}else{$utf8_set=implode(',',$_POST['utf8_set']);}

$utf8_run=neutral_escape($_POST['utf8_run'],1,'int');   neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$utf8_run' WHERE id='utf8_run'");
$utf8_msg=@base64_decode($_POST['utf8_msg']); $utf8_msg=neutral_escape($utf8_msg,512,'str'); neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$utf8_msg' WHERE id='utf8_msg'");
$utf8_set=neutral_escape($utf8_set,999,'str');          neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$utf8_set' WHERE id='utf8_set'");

redirect('admin.php?q=utf8test&ok='.$timestamp);}

/* --- */

if(isset($_POST['msg_style']) && isset($_POST['msg_template'])){

$x=@base64_decode($_POST['msg_style']); $x=neutral_escape($x,1024,'str'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='msg_style'");

$x=@base64_decode($_POST['msg_template']); $x=neutral_escape($x,1024,'str'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='msg_template'");

redirect('admin.php?q=stylemsg&ok='.$timestamp);}

/* --- */

if(isset($_GET['uncache'])){
$forcereload=substr(md5($timestamp),0,9);
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$forcereload' WHERE id='forcereload'");
require_once('admin/recache_as.inc');
redirect('admin.php?q=settings&ok='.$timestamp);}


/* --- */

if(isset($_POST['vvm_on']) && isset($_POST['ask_av']) && isset($_POST['vvm_us']) && isset($_POST['vvm_sz']) && isset($_POST['vvm_la']) && isset($_POST['vvm_lv']) && isset($_POST['vvm_ba']) && isset($_POST['vvm_bv']) && isset($_POST['vvm_rs'])){

$vvm_on=(int)$_POST['vvm_on'];if($vvm_on>1 || $vvm_on<0){$vvm_on=1;}
$ask_av=(int)$_POST['ask_av'];if($ask_av>1 || $ask_av<0){$ask_av=1;}
$vvm_us=(int)$_POST['vvm_us'];if($vvm_us>99 || $vvm_us<1){$vvm_us=5;}
$vvm_sz=(int)$_POST['vvm_sz'];if($vvm_sz>64000000 || $vvm_sz<1000000){$vvm_sz=2000000;}
$vvm_la=(int)$_POST['vvm_la'];if($vvm_la>60 || $vvm_la<5){$vvm_la=10;}
$vvm_lv=(int)$_POST['vvm_lv'];if($vvm_lv>60 || $vvm_lv<5){$vvm_lv=10;}
$vvm_ba=(int)$_POST['vvm_ba'];if($vvm_ba>3 || $vvm_ba<1){$vvm_ba=1;}
$vvm_bv=(int)$_POST['vvm_bv'];if($vvm_bv>5 || $vvm_bv<1){$vvm_bv=1;}
$vvm_rs=(int)$_POST['vvm_rs'];if($vvm_rs>4 || $vvm_rs<1){$vvm_rs=1;}

neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vvm_on' WHERE id='vvm_on'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$ask_av' WHERE id='ask_av'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vvm_us' WHERE id='vvm_us'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vvm_sz' WHERE id='vvm_sz'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vvm_la' WHERE id='vvm_la'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vvm_lv' WHERE id='vvm_lv'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vvm_ba' WHERE id='vvm_ba'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vvm_bv' WHERE id='vvm_bv'");
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$vvm_rs' WHERE id='vvm_rs'");

redirect('admin.php?q=vvmsg&ok='.$timestamp);}

/* --- */

if(isset($_GET['stimoji'])){

if(isset($_GET['stimoji_num'])){$x=(int)$_GET['stimoji_num']; if($x<5 || $x>30){$x=15;} 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='stimoji_num'");}

if(isset($_GET['stimoji_fts'])){$x=(int)$_GET['stimoji_fts']; if($x<0 || $x>1){$x=0;} 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='stimoji_fts'");}

if(isset($_GET['stimoji_dir']) && (trim($_GET['stimoji_dir'])=='' || is_file($_GET['stimoji_dir'].'/keywords.arrays'))){
$x=neutral_escape($_GET['stimoji_dir'],256,'str'); 
neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$x' WHERE id='stimoji_dir'");}

if(isset($_GET['stimoji_dir']) && is_file($_GET['stimoji_dir'].'/keywords.arrays') && isset($_GET['lng'])){
include $_GET['stimoji_dir'].'/keywords.arrays';
neutral_query('DELETE FROM '.$dbss['prfx'].'_stimoji');
foreach ($src_en as $key => $value){
$combined=$value;
if($_GET['lng']=='all' || $_GET['lng']=='fr'){$combined.=' '.$src_fr[$key];}
if($_GET['lng']=='all' || $_GET['lng']=='de'){$combined.=' '.$src_de[$key];}
if($_GET['lng']=='all' || $_GET['lng']=='es'){$combined.=' '.$src_es[$key];}
$combined=neutral_escape($combined,1024,'str');$combined=' '.$combined.' ';
neutral_query('INSERT INTO '.$dbss['prfx']."_stimoji VALUES(NULL,'$key','$combined')");
}}

redirect('admin.php?q=stimoji&ok='.$timestamp);}

/* --- */

if(is_writeable('pwa.webmanifest') && isset($_POST['pwaname']) && isset($_POST['pwasname']) && isset($_POST['pwadesc']) && isset($_POST['pwathemec']) && isset($_POST['pwadisplay']) && isset($_POST['pwabgc'])){

$pwa=array();
$pwa['name']=$_POST['pwaname'];
$pwa['short_name']=$_POST['pwasname'];
$pwa['description']=$_POST['pwadesc'];
$pwa['icons']='ICONS';
$pwa['start_url']='STARTURL';
$pwa['display']=$_POST['pwadisplay'];
$pwa['theme_color']=$_POST['pwathemec'];
$pwa['background_color']=$_POST['pwabgc'];

$pwa=json_encode($pwa,JSON_PRETTY_PRINT);

$icons='[
        {"src":"app/512.png","sizes":"512x512","type":"image/png"}, 
        {"src":"app/256.png","sizes":"256x256","type":"image/png"},
        {"src":"app/128.png","sizes":"128x128","type":"image/png"}
]';

$pwa=str_replace('"ICONS"',$icons,$pwa);
$pwa=str_replace('STARTURL','app/network.html',$pwa);
@file_put_contents('pwa.webmanifest',$pwa);

redirect('admin.php?q=pwa&ok='.$timestamp);}

/* --- */

if(isset($_POST['akey'])){
$akey=abc123a($_POST['akey'],''); $akey=neutral_escape($akey,50,'str');
if(strlen($akey)==25){neutral_query('UPDATE '.$dbss['prfx']."_settings SET value='$akey' WHERE id='server_key'");}
redirect('admin.php');}

} // ends readonly permissions restriction 


if(!isset($_GET['q'])){$q=false;}else{$q=$_GET['q'];}
if(strlen($settings['server_key'])!=25){$q='akey';}

$ext_version=(float)$version;
$int_version=(float)$settings['version'];
if($int_version<$ext_version){$q='update';}

if($permissions['c']<1 && $settings['acpreadonly']==1){
$nocontentaccess=1;
$ronlypages_positive=array('logs','stats','bans');
if(!in_array($q,$ronlypages_positive)){$q=false;}}

if($permissions['c']<1 && $settings['acpreadonly']==2){
$nocontentaccess=1;
$ronlypages_negative=array('messages','msgoff','user','users','dbopt','paint','files');
if(in_array($q,$ronlypages_negative)){$q=false;}}

$unreadoff=0; if($q!='update' && ($permissions['c']>0 || $settings['acpreadonly']==3)){
$res=neutral_query('SELECT COUNT(*) FROM '.$dbss['sprf'].'_offmsg WHERE touserid=0 && msgread=0');
$res=neutral_fetch_array($res);$unreadoff=(int)$res[0];}

switch ($q){
case 'logs'     : $page='logs.pxtm';break;
case 'settings' : $page='settings.pxtm';break;
case 'profiles' : $page='profiles.pxtm';break;
case 'addt'     : $page='additions.pxtm';break;
case 'general'  : $page='general.pxtm';break;
case 'badwords' : $page='badwords.pxtm';break;
case 'ctab'     : $page='ctab.pxtm';break;
case 'ptop'     : $page='ptop.pxtm';break;
case 'gifs'     : $page='gifs.pxtm';break;
case 'stimoji'  : $page='stimoji.pxtm';break;
case 'customjs' : $page='customjs.pxtm';break;
case 'customcss': $page='customcss.pxtm';break;
case 'splash'   : $page='splash.pxtm';break;
case 'mlinks'   : $page='mlinks.pxtm';break;
case 'integra'  : $page='integra.pxtm';break;
case 'style'    : $page='style.pxtm';break;
case 'sounds'   : $page='sounds.pxtm';break;
case 'stylemsg' : $page='stylemsg.pxtm';break;
case 'room'     : $page='room.pxtm';break;
case 'rooms'    : $page='rooms.pxtm';break;
case 'messages' : $page='messages.pxtm';break;
case 'msgoff'   : $page='msgoff.pxtm';break;
case 'user'     : $page='user.pxtm';break;
case 'users'    : $page='users.pxtm';break;
case 'fusers'   : $page='fusers.pxtm';break;
case 'group'    : $page='group.pxtm';break;
case 'groups'   : $page='groups.pxtm';break;
case 'grule'    : $page='grule.pxtm';break;
case 'grules'   : $page='grules.pxtm';break;
case 'files'    : $page='files.pxtm';break;
case 'paint'    : $page='paint.pxtm';break;
case 'update'   : $page='update.pxtm';break;
case 'akey'     : $page='akey.pxtm';break;
case 'vvmsg'    : $page='vvmsg.pxtm';break;
case 'fbook'    : $page='facebook.pxtm';break;
case 'mapps'    : $page='mapps.pxtm';break;
case 'utf8test' : $page='utf8test.pxtm';break;
case 'dbopt'    : $page='database.pxtm';break;
case 'pguard'   : $page='pguard.pxtm';break;
case 'machines' : $page='machines.pxtm';break;
case 'jbox'     : $page='jbox.pxtm';break;
case 'sequence' : $page='sequence.pxtm';break;
case 'rbox'     : $page='rbox.pxtm';break;
case 'idx'      : $page='idx.pxtm';break;
case 'nbox'     : $page='nbox.pxtm';break;
case 'subset'   : $page='subset.pxtm';break;
case 'gbox'     : $page='gbox.pxtm';break;
case 'gset'     : $page='gset.pxtm';break;
case 'abox'     : $page='abox.pxtm';break;
case 'tips'     : $page='tips.pxtm';break;
case 'polls'    : $page='polls.pxtm';break;
case 'stats'    : $page='stats.pxtm';break;
case 'widgets'  : $page='widgets.pxtm';break;
case 'pwa'      : $page='pwa.pxtm';break;
case 'bbox'     : $page='bbox.pxtm';break;
case 'bling'    : $page='bling.pxtm';break;
case 'map'      : $page='map.pxtm';break;
case 'mapfetch' : $page='map.pxtm';break;
case 'mapsetts' : $page='mapsetts.pxtm';break;
case 'quizzes'  : $page='quizzes.pxtm';break;
case 'landing'  : $page='landing.pxtm';break;
case 'seo'      : $page='seopage.pxtm';break;
case 'vip'      : $page='vip.pxtm';break;
case 'vips'     : $page='vips.pxtm';break;
case 'vipshop'  : $page='vipshop.pxtm';break;
case 'vshopid'  : $page='vshopid.pxtm';break;
case 'vshoplog' : $page='vshoplog.pxtm';break;
case 'bans'     : $page='bans.pxtm';break;
case 'verify'   : $page='verify.pxtm';break;
default         : $page='board.pxtm';break;
}

require_once 'admin/'.$page;

?>
