<?php

function time_to_run(){
$time=microtime();
$time=explode(' ',$time);
return $time[1]+$time[0];}

$stime=time_to_run();

require_once('config.php');
require_once('incl/main.php');

neutral_dbconnect(); $settings=get_settings();

header('Content-Type:text/plain');
if(!isset($_GET['q']) || $_GET['q']!=$settings['crn_k']){print 'Forbidden, exiting...';die();}

$newsapikey=$settings['newsapi_key'];
if(strlen($newsapikey)<30){print 'Invalid API key!';die();}

print 'Security key: OK'."\r\n";

// ---

$ncount=0;

// ---

function inews($n,$t){
global $ncount,$dbss;$tstamp=time();
$news=json_decode($n,true); $idnbox=(int)$t;
if(!isset($news['status']) || $news['status']!='ok'){return;}
foreach($news['articles'] as $value) {
$ncount+=1;
$nhead=neutral_escape($value['title'],256,'str');
$npubl=neutral_escape($value['source']['name'],32,'str');
$ndate=neutral_escape($value['publishedAt'],10,'str');
$ndesc=neutral_escape($value['description'],2048,'str');
$nlink=neutral_escape($value['url'],1024,'str');
$npict=neutral_escape($value['urlToImage'],1024,'str');
neutral_query('INSERT INTO '.$dbss['prfx']."_news VALUES(NULL,$idnbox,0,'$nhead','$npubl','$ndate','$ndesc','$nlink','$npict')");
}neutral_query('UPDATE '.$dbss['prfx'].'_nbox SET lastrun='.$tstamp.' WHERE id='.$idnbox);}

// ---

$breaknewsurl='https://newsapi.org/v2/top-headlines?pageSize=%PAGESIZE%&country=%ORIGIN%&apiKey=%APIKEY%';
$everynewsurl='https://newsapi.org/v2/everything?q=%TOPIC%&pageSize=%PAGESIZE%&sortBy=publishedAt&language=%ORIGIN%&apiKey=%APIKEY%';

neutral_query('DELETE FROM '.$dbss['prfx'].'_news');

$fetchnews=neutral_query('SELECT * FROM '.$dbss['prfx'].'_nbox WHERE enabled>0');

$nprs=neutral_num_rows($fetchnews);

while($row=neutral_fetch_array($fetchnews)){

$topic=urlencode($row['topic']);

if($row['headlines']>0){
$fetchnewsurl=str_replace('%TOPIC%',$topic,$breaknewsurl);
$fetchnewsurl=str_replace('%APIKEY%',$newsapikey,$fetchnewsurl);
$fetchnewsurl=str_replace('%PAGESIZE%',$row['pagesize'],$fetchnewsurl);
$fetchnewsurl=str_replace('%ORIGIN%',$row['origin'],$fetchnewsurl);}
else{
$fetchnewsurl=str_replace('%TOPIC%',$topic,$everynewsurl);
$fetchnewsurl=str_replace('%APIKEY%',$newsapikey,$fetchnewsurl);
$fetchnewsurl=str_replace('%PAGESIZE%',$row['pagesize'],$fetchnewsurl);
$fetchnewsurl=str_replace('%ORIGIN%',$row['origin'],$fetchnewsurl);}

$newsapiresult=curlfgc($fetchnewsurl);
inews($newsapiresult,$row['id']);

}

$etime=time_to_run();
$ttr=round($etime-$stime,3);

print 'Requests to newsapi: '.$nprs."\r\n";
print 'News inserted in DB: '.$ncount."\r\n";
print 'Execution time /all: '.$ttr.'s';

?>