<?php

if(!isset($settings) || !is_array($settings)){die();}

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

require 'incl/phpmailer_Exception.php';
require 'incl/phpmailer_PHPMailer.php';
require 'incl/phpmailer_SMTP.php';

// -----------------------

function send_smtp_mail($to, $subject, $message, $debug){
global $settings; $error_msg='';

$debug=(int)$debug; if($debug<0 || $debug>3){$debug=0;}

$mail = new PHPMailer;

$mail->SMTPDebug = $debug;
$mail->isSMTP();
$mail->Host = $settings['vpm_smtp_host'];
$mail->SMTPAuth = $settings['vpm_smtp_auth'];
$mail->Username = $settings['vpm_smtp_user'];
$mail->Password = $settings['vpm_smtp_pass'];
$mail->SMTPSecure = $settings['vpm_smtp_secu'];
$mail->Port = $settings['vpm_smtp_port'];

$mail->CharSet = 'utf-8';
$mail->Encoding = 'quoted-printable';
$mail->addAddress($to);

if(strlen($settings['vpm_smtp_mail'])>1){$mail->XMailer = $settings['vpm_smtp_mail'];}else{$mail->XMailer = ' ';}
if(strlen($settings['vpm_smtp_more'])>5){$mail->SMTPOptions = $settings['vpm_smtp_more'];}
if(strlen($settings['vpm_smtp_from'])>5){$mail->setFrom($settings['vpm_smtp_from']);}

$mail->Subject = $subject;
$mail->Body    = $message;

if(!$mail->send()) {

	if($debug>0){
	$error_msg=$mail->ErrorInfo;
	return "\n\nERROR: ".$error_msg;}
	else{return false;}
}

else {
	if($debug>0){return "\n\nSUCCESS!";}
	else{return true;}

}
}

?>