<?php

if(!isset($_POST['mtoken']) || !isset($_POST['rtoken'])){die();}

if(isset($_POST['room'])){$room=(int)$_POST['room'];}else{$room=0;}
if(isset($_POST['tuid'])){$tuid=(int)$_POST['tuid'];}else{$tuid=0;}
if(isset($_POST['zone'])){$zone=(int)$_POST['zone'];}else{$zone=0;}
if(isset($_POST['ampm'])){$ampm=(int)$_POST['ampm'];}else{$ampm=2;}

if(($tuid+$room)<1){print 'error 002';die();}

require_once('config.php');
require_once('incl/main.php');

neutral_dbconnect(); $settings=get_settings(); get_language(); 
if(function_exists('customphp')){customphp();} 

function tformat($t,$z,$a){
if($a<1){return '';}
if($a>1){$f='Y-m-d H:i';}else{$f='Y-m-d h:i';}
return gmdate($f,$t+$z*60);}

if($settings['msg2db']<1){print 'error 003';die();}
if(!isset($settings['tns_length'])){$tns_length=200;}else{$tns_length=(int)$settings['tns_length'];}
if(!isset($settings['tns_lowprv'])){$tns_lowprv=0;}else{$tns_lowprv=(int)$settings['tns_lowprv'];}

$url= "{$_SERVER['HTTP_HOST']}{$_SERVER['PHP_SELF']}";
$url=str_replace('transcript.php','',$url);

$mtoken=explode('|',$_POST['mtoken']);
$rtoken=explode('|',$_POST['rtoken']);
$mmtoken=htmlspecialchars($_POST['mtoken']);
$rrtoken=htmlspecialchars($_POST['rtoken']);

if(!isset($mtoken[5])){print 'error 004';die();}
$m_hash=hash('sha256',$mtoken[0].$mtoken[1].$mtoken[2].$mtoken[3].$mtoken[4].$settings['random_salt']);
if($m_hash!=$mtoken[5]){print 'error 005';die();}

if(!isset($rtoken[1])){print 'error 006';die();}
$r_hash=hash('sha256',$rtoken[0].$settings['random_salt']);
if($r_hash!=$rtoken[1]){print 'error 007';die();}

$permission2see=explode(',',base64_decode($rtoken[0]));

// ---

$userid=(int)$mtoken[0];
$title=tformat($timestamp,$zone,$ampm);
$title=str_replace(':','',$title);
$title=str_replace(' ','_',$title);

$html_log=array();
$text_log=array();
$blings=array();

$t_name=false; $r_name=false;

$rboxsender=explode(':',$settings['rbox_sender']);$rboxsender=$rboxsender[2];
$nboxsender=explode(':',$settings['nbox_sender']);$nboxsender=$nboxsender[2];
$gboxsender=explode(':',$settings['gbox_sender']);$gboxsender=$gboxsender[2];

if($room>0){
if(!in_array($room,$permission2see)){print 'error 008';die();}
$res=neutral_query('SELECT * FROM '.$dbss['prfx'].'_rooms  WHERE id='.$room);
if(neutral_num_rows($res)<1){print 'error 009';die();}
$res=neutral_fetch_array($res);$r_name=htmlspecialchars($res['name']);

$blingfromdb=neutral_query('SELECT blingkey FROM '.$dbss['prfx'].'_bbox');
while($row=neutral_fetch_array($blingfromdb)){$blings[]=$row['blingkey'];}

$query='SELECT * FROM '.$dbss['prfx']."_messages WHERE roomid=$room AND mhash<>'' ORDER BY id DESC LIMIT $tns_length OFFSET 0";}

if($tuid>0){$query='SELECT * FROM '.$dbss['prfx']."_messages WHERE roomid=0 AND mhash<>'' AND ((touserid=$userid AND userid=$tuid) OR (touserid=$tuid AND userid=$userid)) ORDER BY id DESC LIMIT $tns_length OFFSET 0";}

$res=neutral_query($query);
while($row=neutral_fetch_array($res)){

$time=tformat($row['timestamp'],$zone,$ampm);
$shorttime=substr($time,11);
$cuid=$row['userid'];
$user=$row['username'];
$line=$row['line'];

if($row['attach']>99){$user=$rboxsender;}

switch($row['attach']){
case 1 : if($tns_lowprv>0){$line='(IMAGE) '.$url.$line;}else{$line='(IMAGE)';} break;
case 2 : if($tns_lowprv>0){$line='(VIDEO) '.$url.$line;}else{$line='(VIDEO)';} break;
case 3 : if($tns_lowprv>0){$line='(AUDIO) '.$url.$line;}else{$line='(AUDIO)';} break;
case 4 : $line='(DICE)';break;
case 5 : $line='(MAP) '.$line;break;
case 6 : $line='(YOUTUBE) https://youtu.be/'.$line;break;
case 7 : $line='(SOUNDCLOUD) https://soundcloud.com/'.$line;break;
case 8 : $line='(VIMEO) https://vimeo.com/'.$line;break;
case 9 : $line='(MIXCLOUD) https://mixcloud.com'.str_replace('.','/',$line);break;
case 10 : $line='//giffy';break;
case 11 : $line='(CODE)';break;
case 14 : $line='(DOODLE)';break;
case 15 : $line='(GIF)';break;
case 16 : $line='(STICKER)';break;
case 17 : if($tns_lowprv>0){$line='(VOICE MSG) '.$url.$line;}else{$line='(VOICE MSG)';} break;
case 18 : if($tns_lowprv>0){$line='(VIDEO MSG) '.$url.$line;}else{$line='(VIDEO MSG)';} break;
case 19 : $user=$nboxsender;$line='(NEWS)';break;
case 21 : $user=$gboxsender;$line='(GIF)';break;
case 24 : $line='//tiktok';break;
case 25 : $line='(POLL)';break;
case 27 : $line='(TEXTSTREAM)';break;
case 99 : $line='(FILE)';break;}

$line=str_replace(['[b]','[i]','[/b]','[/i]'],'',$line);
$line=preg_replace('/«([\S])»/mu','$1',$line);

$bwords=explode(',',$settings['badwords']);
$rwords=explode(',',$settings['badrepls']);
if(count($bwords) == count($rwords) && count($bwords)>0){$line=str_ireplace($bwords,$rwords,$line);}

$line_h=htmlspecialchars($line);
$line_h=str_replace('[br]','<br />',$line_h);

$line_t=str_replace("'",'x}{x',$line);
$line_t=str_replace("<",'y}{y',$line_t);
$line_t=str_replace('[br]',' | ',$line_t);

if($cuid==$userid && $row['attach']!=19 && $row['attach']!=21 && $row['attach']>-1){
$ms='class="bb"';}else{$ms='';$t_name=$user;}

if(!in_array($line,$blings) && $line!=$settings['clearscreen']){
$html_log[]='<i title="'.$time.'">'.$shorttime.'</i> <b '.$ms.'>'.$user.'</b> '.$line_h;
$text_log[]='['.$time.'] ('.$user.') '.$line_t;
}}

$html_log=array_reverse($html_log); $text_log=array_reverse($text_log);
$html_log=implode('<br>',$html_log);
$text_log=implode('{br}',$text_log);

$tsname='';
if($r_name){$tsname=' ('.$r_name.')';}
else{if($t_name){$tsname=' ('.$t_name.')';}}

?>
<!DOCTYPE html>
<html lang="en"><head>
<!-- room:<?php print $room;?> -->
<title>...</title>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, height=device-height, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" />
<script>

mobileapp=0;

function dnd(){
t='<?php print $text_log;?>'
t=t.replace(/{br}/g,'\r\n')
t=t.replace(/x}{x/g,"'")
t=t.replace(/y}{y/g,'<')

a=document.getElementById('ah')
file=new Blob([t],{type:'text/plain'})
a.href=URL.createObjectURL(file)
a.setAttribute('download','<?php print $title;?>.txt')}

<?php if(isset($_COOKIE['mobileapp'])){print 'mobileapp=1;';} ?>

</script>
<style>
body{color:#222;background-color:#eee}
i{cursor:default}
a{display:inline-block;color:#eee;border-width:0;border-radius:100%;font-weight:bold;line-height:32px;text-align:center;height:32px;width:32px;text-decoration:none}
b{display:inline-block;color:#283593;margin-top:5px} .bb{color:#1B5E20}
#ts{position:fixed;top:0;right:0;left:0;bottom:0;padding:5px;overflow:auto;font-size:13px;font-family:sans-serif}
</style>
</head>
<body onload="bts=document.getElementById('ts');bts.scrollTop=bts.scrollHeight">

<div id="ts">
<div style="font-weight:bold;font-size:120%"><?php print $lang['transcript'].'<span style="font-weight:normal">'.$tsname;?></span></div>
<br /><?php print $html_log;?></div>

<div style="position:fixed;top:5px;right:20px;opacity:0.7">
<a href="#ah" id="ah" style="background-color:#1565C0" onclick="dnd()">↓</a>
<a href="#wo" id="wo" style="background-color:#EF6C00" onclick="document.forms[0].submit()">↗</a>
</div>

<form method="post" action="transcript.php" target="_blank">
<input type="hidden" name="room" value="<?php print $room;?>" />
<input type="hidden" name="tuid" value="<?php print $tuid;?>" />
<input type="hidden" name="zone" value="<?php print $zone;?>" />
<input type="hidden" name="ampm" value="<?php print $ampm;?>" />
<input type="hidden" name="mtoken" value="<?php print $mmtoken;?>" />
<input type="hidden" name="rtoken" value="<?php print $rrtoken;?>" />
</form>

<script>
if(parent.length<1 || mobileapp>0){document.getElementById('wo').style.display='none'}
</script>

</body></html>